/* coding: utf-8 */
/* Copyright (C) 2021 SofTek Systems, Inc. */

$(function(){

    function execute_filter(filters){
        reset_pages_checked_values();
        $('#pages_filters').val(JSON.stringify(filters));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
        return false;
    };

    //prevent dropdown-menu from closing by click
    $('.filter-dropdown-menu *').on('click', function(e){
        e.stopPropagation();
    });

    //期間指定検索
    $('.filter-date-preset').on('click', function() {
        $('#filters_search_date_begin').val($(this).data('begindate'));
        $('#filters_search_date_end').val($(this).data('enddate'));
        $('#filters_search_date_in_rev').prop('checked', $(this).data('inrev') ? true : false);
        return false;
    });


    $('#filter-date-form').on('submit', function() {
        var pages_filters = $('#pages_filters');
        var filters = JSON.parse(pages_filters.val());
        var begindate = $('#filters_search_date_begin').val();
        var enddate = $('#filters_search_date_end').val();
        var inrev = $('#filters_search_date_in_rev').prop('checked');
        var v = (inrev ? 'rev' : 'in') + ':' + begindate + ':' + enddate;
        filters['date'] = String(v);
        execute_filter(filters);
        return false;
    });

    $('#reset-filter-date').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['date'] = '::';
        execute_filter(filters);
        return false;
    }); 

    //SRI検索
    $('#exec-filter-statuses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        var sris = [];
        $('#filter-statuses-menu [data-sri]:checked').each(function(){
            sris.push($(this).val());
        });
        filters['sris'] = sris;
        filters['warning'] = 'all';
        execute_filter(filters);
        return false;
    }); 

    $('#reset-filter-statuses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['sris'] = [];
        execute_filter(filters);
        return false;
    });

    //CVSS検索
    $('#exec-filter-cvsses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        var cvsses = [];
        $('#filter-cvsses-menu [data-cvss]:checked').each(function(){
            cvsses.push($(this).val());
        });
        filters['cvsses'] = cvsses;
        filters['warning'] = 'all';
        execute_filter(filters);
        return false;
    });

    $('#reset-filter-cvsses').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['cvsses'] = [];
        execute_filter(filters);
        return false;
    });

    //履歴検索
    $('.filter-journal-preset').on('click', function(){
       $('#filters_search_journal_begin').val($(this).attr('data-begindate'));
       $('#filters_search_journal_end').val($(this).attr('data-enddate'));
       $('#filters_search_journal_in_rev').prop('checked', $(this).data('inrev') ? true : false);
       return false;
   });

   $('#filter-journal-form').on('submit', function(){
       var begindate = $('#filters_search_journal_begin').val();
       var enddate = $('#filters_search_journal_end').val();
       if( begindate == '' && enddate == '' ){
           alert('期間を指定して下さい');
           return false;
       }
       var filters = JSON.parse($('#pages_filters').val());
       var inrev = $('#filters_search_journal_in_rev').prop('checked');
       var v = (inrev ? 'rev' : 'in') + ':' + begindate + ':' + enddate;
       filters['journal']['period'] = String(v);
       filters['journal']['filter_status_change'] = $('#filter-journal-filter-status-change').prop('checked');
       filters['journal']['filter_duedate_change'] = $('#filter-journal-filter-duedate-change').prop('checked');
       execute_filter(filters);
       return false;
   });

   $('#reset-filter-journal').on('click', function(){
       var filters = JSON.parse($('#pages_filters').val());
       filters['journal']['period'] = '::';
       filters['journal']['filter_status_change'] = false;
       filters['journal']['filter_duedate_change'] = false;
       execute_filter(filters);
       return false;
   });

   //カテゴリ検索(複数)
   $('#filter-categories-is-and-check-box').on('change', function(){
        if( $(this).prop('checked') ){
            $('#filter-categories-is-except-check-box').prop('checked', false);
        }
    });

    $('#filter-categories-is-except-check-box').on('change', function(){
        if( $(this).prop('checked') ){
            $('#filter-categories-is-and-check-box').prop('checked', false);
        }
    });

    $('#exec-filter-categories').on('click', function(){
        var cat_ids = [];
        $('#filter-categories-menu .category-select:checked').each(function(){
            cat_ids.push($(this).val());
        });
        if( cat_ids.length === 0){
            alert('カテゴリを1つ以上選択して下さい');
            return false;
        }
        var filters = JSON.parse($('#pages_filters').val());
        filters['categories']['ids'] = cat_ids;
        filters['categories']['is_and'] = $('#filter-categories-is-and-check-box').prop('checked');
        filters['categories']['is_except'] = $('#filter-categories-is-except-check-box').prop('checked');
        execute_filter(filters);
    });

    //カテゴリ検索リセット
    $('#reset-filter-categories').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['categories']['ids'] = [];
        filters['categories']['is_and'] = false;
        filters['categories']['is_except'] = false;
        execute_filter(filters);
    });

});
