/* Copyright (C) 2018- SofTek Systems, Inc. */

//ajaxのタイムアウト時間。脆弱性別状況・脆弱性詳細・ホスト別状況・ホスト詳細画面で使用する。
const AJAX_TIMEOUT_SECOND = 30000;

//ブラウザ情報
var browser_ident = '';
var user_agent = window.navigator.userAgent.toLowerCase();
if(user_agent.indexOf('msie') != -1 || user_agent.indexOf('trident') != -1) {
    //Internet Explorer
} else if(user_agent.indexOf('edge') != -1) {
    //Edge;
} else if(user_agent.indexOf('chrome') != -1) {
    browser_ident = 'Chrome';
} else if(user_agent.indexOf('safari') != -1) {
    browser_ident = 'Safari';
} else if(user_agent.indexOf('firefox') != -1) {
    browser_ident = 'FireFox';
}
const Browser_Ident = browser_ident;

// 配列同士の比較
Array.prototype.compare = function(e) {
    if (!(e instanceof Array)) {
	throw new TypeError('argument type is not array.');
    }
    var a = JSON.stringify(this.sort());
    var b = JSON.stringify(this.sort());
    return (a === b);
};

// svg のエレメントを返す。
// 必ずこれを使用すること。jqueryでエレメントを生成すると、Google Chrome以外で出力されないため。
function $s(elem) {
    return $(document.createElementNS('http://www.w3.org/2000/svg', elem));
}

// 初期化
function init_sidfm() {
    logging_error();
    enable_bootstrap_actions(null);
    html_title_update();
    force_click_ignore();
    header_title_update();
    //bootstrapのpopoverを、modalが開くときに閉じる。
    $('.modal').on('show.bs.modal', function(){
        $('[data-toggle="popover"]').popover('hide');
    });
   
    //resizeで消去
    $(window).on('resize',function(){
        $('[data-toggle="dropdown"]').dropdown('hide');
    });
}

// 指定したtarget配下についてtooltip, popoverを有効にする。
// targetに!targetがtrueになる値(null等)を設定すると、全体が対象となる。
function enable_bootstrap_actions(target) {
    if (!target) { target = ''; } else { target = target + ' '; }
    $(target + '[data-toggle="datepicker"]').datepicker({
	currentText: '今日',
	monthNames: [ '1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月' ],
	monthNamesShort: [ '1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月' ],
	dayNames: [ '日曜日', '月曜日', '火曜日', '水曜日', '木曜日', '金曜日', '土曜日' ],
	dayNamesShort: [ '日', '月', '火', '水', '木', '金', '土' ],
	dayNamesMin: [ '日', '月', '火', '水', '木', '金', '土' ],
	weekHeader: '週',
	dateFormat: 'yy/mm/dd',
	firstDay: 0,
	showButtonPanel: true,
	showMonthAfterYear: true,
	yearSuffix: '年',
	closeText: '閉じる'
    });
    // datepickerの「閉じる」ボタンでメニューまで閉じないようにする。
    $('#ui-datepicker-div').on('click', function(e) {
	e.stopPropagation();
	return false;
    });
    $('[data-toggle="dropdown"]').parent().on('hide.bs.dropdown', function(){
        $('[data-toggle="datepicker"]').datepicker('hide'); 
    });
    $(target + '[data-toggle="tooltip"]').tooltip();
    $(target + '[data-toggle="popover"]').popover();
}

// paginator用アクション
function init_paginator(base = 'pages') {
    $('.' + base + '_change_offset_paging').on('click', function() {
	$('#' + base + '_offset').val($(this).data('offset'));
	$('#' + base + '_form').submit();
	return false;
    });
    $('.' + base + '_change_per_page').on('change', function() {
	$('#' + base + '_per_page').val($(this).val());
	$('#' + base + '_form').submit();
	return false;
    });
    $('.' + base + '_change_offset_direct').on('keypress', function(e) {
	if (e.which == 13) {
	    var offset = parseInt($(this).val()) - 1;
	    //if (offset < 0) { offset = 1; }
	    if(offset < 0) { offset = 0; }
	    $('#' + base + '_offset').val(String(offset));
	    $('#' + base + '_form').submit();
	    return false;
	}
	return true;
  
    });
}

// sidebarについて、指定したidのアイテムをactiveにする
function activate_sidebar_item(id) {
  $('.nav-sidebar li').removeClass('active');
  $('#' + id).addClass('active');
}

// 選択された項目を別の項目に移動する。
// 2ペインのマルチセレクト入力用
//   p_selected_ids         : 選択された項目IDの一覧を保存している場所。hidden fieldのvalue等を想定。
//   p_current_selected     : 選択された項目のあるselectの場所。
//   p_opposite_selected    : 反対側の項目のあるselectの場所。
//   flg_reverse            : falseなら選択されたidを追加、trueなら選択されたidを除外。
function move_selected_items(p_selected_ids, p_current_selected, p_opposite_selected, flg_reverse) {
    var selected_ids = JSON.parse($(p_selected_ids).val());
    var options = $(p_current_selected + ' > option:selected');
    for (var i = 0; i < options.length; i++) {
        var option = $(options[i]);
        var s_id = parseInt(option.val());
        var s_text = option.text();
        var desc = option.data('title');
        if (flg_reverse) {
            selected_ids = selected_ids.filter(function(x, i, self) {
                return x != s_id;
            });
            selected_ids = selected_ids.filter(function(x, i, self) {
                return self.indexOf(x) == i;
            });
        } else {
            selected_ids.push(s_id);
            selected_ids = selected_ids.filter(function(x, i, self) {
                return self.indexOf(x) == i;
            });
        }
        $(p_selected_ids).val(JSON.stringify(selected_ids));
        $(p_opposite_selected).append(
            $('<option></option>', { value: s_id, text: s_text, class: 'text-truncate g-max-width-21em', 'data-toggle': 'tooltip', 'data-placement': 'right', 'data-title': desc, 'data-boundary': 'window' })
        );
    }
    $(p_current_selected + ' > option:selected').remove();
   
    return false;
}

// heatmapの出力。
// width, height はpx単位。
// width=360, height=180で10000件程度なら問題なく表示できることを確認。
// targetはid等の文字列(内部で$()で解釈します)、dataはjqueryのエレメント
// になることに注意。
function heatmap(target, width, height, data, callback) {
    if (width <= 0 || height <= 0) {
	return;
    }
    var container = $('<div></div>');
    var svg = $s('svg').attr({
	xmlns: 'http://www.w3.org/2000/svg',
	'xmlns:xlink': 'http://www.w3.org/1999/xlink',
        preserveAspectRatio: 'xMinYMin meet',
	viewBox: '0 0 ' + width + ' ' + height,
	x: '0px',
	y: '0px',
	width: '' + width + 'px',
	height: '' + height + 'px',
	version: '1.1'
    });
    container.append(svg);
    var rect_x = Math.floor(width * (3.0/100.0));
    var rect_y = Math.floor(width * (3.0/100.0));
    var rect_width = width - (rect_x * 2);
    var rect_height = height - (rect_y);
    svg.append($s('rect').attr({
	x: '' + rect_x + 'px',
	y: '' + rect_y + 'px',
	fill: '#f8f8f8',
	width: '' + rect_width + 'px',
	height: '' + rect_height + 'px'
    }));
  /*  var x_grid_count = Math.floor(Math.sqrt(data.length * (rect_width / rect_height)));
    var y_grid_count = Math.floor(data.length / x_grid_count) + 1;
    var x_grid_size = rect_width / x_grid_count;
    if (x_grid_size > ((0.0 + rect_width) * 30.0 / 100.0)) { x_grid_size = Math.floor((0.0 + rect_width) * 30.0 / 100.0); }
    var y_grid_size = rect_height / y_grid_count;
    if (y_grid_size > ((0.0 + rect_height) * 60.0 / 100.0)) { y_grid_size = Math.fllor((0.0 + rect_height) * 60.0 / 100.0); } */
    if(rect_width >= rect_height){
        var x_grid_count = Math.ceil(Math.sqrt(data.length) * (rect_width / rect_height));
        var y_grid_count = Math.floor(data.length / x_grid_count) + 1;
        var x_grid_size = rect_width / x_grid_count;
        var y_grid_size = x_grid_size;
    }else{
        var x_grid_count = Math.ceil(Math.sqrt(data.length) * (rect_width / rect_height));
        var y_grid_count = Math.floor(data.length / x_grid_count) + 1;
        var x_grid_size = rect_height / y_grid_count;
        x_grid_count = Math.floor(rect_width / x_grid_size);
        var y_grid_size = x_grid_size;
    } 

    for (var i = 0; i < data.length; i++) {
	var x_grid_position = i % x_grid_count;
	var y_grid_position = Math.floor(i / x_grid_count);

	var x_grid_left = rect_x + x_grid_size * x_grid_position;
	var y_grid_top = rect_y + y_grid_size * y_grid_position;
        //var callback_result = callback.call(this, data.get(i));
        var callback_result = callback.call(this, data[i]);
	var link = $s('a').attr({
            'xlink:href': callback_result.link,
            'data-toggle': 'tooltip',
            'data-container': 'body',
            'data-placement': 'top',
            'data-trigger': 'hover',
            'data-html': 'true',
            'title': callback_result.tooltip
	});

	var rect_opts = {
            x: '' + x_grid_left + 'px',
            y: '' + y_grid_top + 'px',
            fill: callback_result.color,
            width: '' + x_grid_size + 'px',
            height: '' + y_grid_size + 'px'
	};

	// データが少ない場合のみ枠線あり。
	if (data.length < 2000) {
	    rect_opts['stroke'] = 'black';
	    rect_opts['stroke-width'] = '0.5px';
	}

	link.append($s('rect').attr(rect_opts));
	svg.append(link);
    }

    // このようにしないとsvgが解釈されない。
    $(target).html(container.html());
    enable_bootstrap_actions(target);
}

// グラディエーションの計算
// s, eはそれぞれ変換の始端・終端の色をHashで指定する。
//   { r: 1, g: 2, b: 3 }
// pは変化の割合(%)
function calc_gradient_color(s, e, p) {
    var ret = { r:0, g:0, b:0 };
    var keys = [ 'r', 'g', 'b' ];
    for (var i = 0; i < keys.length; i++) {
      ret[keys[i]] = Math.floor((e[keys[i]] - s[keys[i]]) * p / 100.0 + s[keys[i]]);
    }

    return ret;
}

// hex形式の色をcalc_gradient_colorでで使用する形式に変換
function from_hex_to_rgb(hex) {
    var res = ('' + hex).match(/^#([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/);
    var r = parseInt(res[1], 16);
    var g = parseInt(res[2], 16);
    var b = parseInt(res[3], 16);
    return { r:r, g:g, b:b };
}

// calc_gradient_colorで返すrgbのHashを色指定用の文字列(rgb)に変換
function to_rgb_str(s) {
    return 'rgb(' + s.r + ',' + s.g + ',' + s.b + ')';
}

// calc_gradient_colorで返すrgbのHashを色指定用の文字列(hex)に変換
function to_rgb_hex(s) {
    return '#' +
	[ 'r', 'g', 'b' ].map(function(i) {
	    return ('0' + s[i].toString(16)).slice(-2);
	}).join('');
}

// color_引数のidが存在する場合に、その値を取得して返す。
function symbol_color(color) {
    var c = $('#color_' + color);
    return c.length ? c.val() : c;
}

// SidfmHelper#status_barとほぼ同じ動作。
// modal のように動的処理で生成する必要のある場所で採用。   
function status_bar(width, height, data, unit, opts) {
    opts = (typeof opts === 'undefined') ? {} : opts;
    opts['width'] = '' + width + 'px';
    opts['height'] = '' + height + 'px';
    opts['xmlns'] = 'http://www.w3.org/2000/svg';
    opts['version'] = '1.1';
    var svg = $s('svg').attr(opts);
    var data_size = data.length;
    var value_sum = 0;
    for (var i = 0; i < data_size; i++) {
	value_sum += data[i]['value'];
    }
    var unit_width = parseFloat(width) / parseFloat(value_sum);
    var current_x = 0;
    for (var i = 0; i < data_size; i++) {
	var w = Math.floor(unit_width * parseFloat(data[i]['value']));
	var html = "<svg xmlns='http://www.w3.org/2000/svg' version='1.1' width='12px' height='12px'><rect x='0' y='0' width='10' height='12' fill='" + symbol_color(data[i]['color']) + "' /></svg>" + data[i]['name'] + ":" + data[i]['value'] + unit;
	var a_opt = {
	    'data-toggle': 'tooltip',
	    'data-container': 'body',
	    'data-placement': data[i]['placement']  || 'bottom',
	    'data-html': 'true',
	    title: html
	};
	var a = $s('a').attr(a_opt);
	svg.append(a);
	var rect_opt = {
	    x: '' + current_x,
	    y: '0',
	    width: '' + w,
	    height: '' + height,
	    fill: symbol_color(data[i]['color'])
	};
	a.append($s('rect').attr(rect_opt));
	current_x += w;
    }
    return svg;
}

// QUERY_STRINGを考慮して現在のURLにパラメータを付与する
function append_link(append_opt) {
    var ret = location.href;
    if (ret.indexOf('?') >= 0) {
	ret += '&' + append_opt;
    } else {
	ret += '?' + append_opt;
    }
    return ret;
}

// Stacked Fill Graphで使用。yの値にbaseのyの値を加算して返す。
function calc_stacked(base, stack) {
    for (var i = 0; i < base['y'].length; i++) {
	stack['y'][i] += base['y'][i];
    }
    return stack;
}

// 指定した箇所の幅を取得し、グラフの幅を計算して返す。
function graph_width(target) {
    return $(target).innerWidth() - 10;
}

//
function url_replace_id(target, id) {
    return $(target).val().replace('___id___', '' + id);
}

// 指定されたidのホスト詳細画面のURLを返す。
function url_host_detail(id) {
    return url_replace_id('#sidfm_host_path', id);
}

// 指定されたidの脆弱性詳細画面のURLを返す。
function url_vulnerabilities_detail(id) {
    return url_replace_id('#sidfm_vulnerability_path', id);
}
function url_vulnerability_detail(id) {
    return url_replace_id('#sidfm_vulnerability_path', id);
}

//
function url_info_product_detail(id) {
    return url_replace_id('#sidfm_informations_product_path', id);
}

//
function url_info_vuln_detail(id) {
    return url_replace_id('#sidfm_informations_vuln_path', id);
}

// <title></title>の文字列にSIDfm VMが含まれていたら、SIDfm&trade; VM
// に変更する
function html_title_update() {
    $('title').html($('title').html().replace('SIDfm', 'SIDfm&trade;'));
}

// 指定した要素にclickに反応しないようにする。
// FIXME: 既にclickイベントが登録されている場合への対応
function force_click_ignore() {
    $('.ignore-click').on('click', function() {
	return false;
    });
}

// ソート処理
function sort_toggle(name, base = 'pages') {
    return (function() {
	var order = $('#' + base + '_order').val();
	if (order == name + '_asc') {
	    $('#' + base + '_order').val(name + '_desc');
	} else {
	    $('#' + base + '_order').val(name + '_asc');
	}
	$('#' + base + '_form').submit();
	return false;
    });
}

// URLやパスから、anchor (fragment) を削除する
function remove_anchor(str) {
    return (str ? str.replace(/#[0-9a-zA-z_-]+$/, '') : '');
}

// ヘッダのタイトルを更新する。
function header_title_update(title) {
    var header_title = $('#sidfm_header_title');
    var vm_page_title = $('#vm_page_title').text();
    header_title.text(vm_page_title);
    header_title.removeClass('d-none');
}

// windows.onerrorでアプリケーションにロギングする
// なお、ログイン状態でないとロギングに失敗する（仕様）
function logging_error() {
    window.onerror = function(msg, file, line, column, err) {
	if (!msg) { msg = '(no msg)'; }
	if (!file) { file = '(no file)'; }
	if (!line) { line = '(unknown)'; }
	if (!column) { column = 0; }
	if (!err) { err = null; }
	
	var logger_path = $('#sidfm_internal_api_logger_path').val();
	if (logger_path) {
	    $.post(logger_path,
		   { 'params[msg]': msg,
		     'params[file]': file,
		     'params[column]': column,
		     'params[line]': line,
		     'params[err]': err },
		   function(data) {
		       console.log('msg: ' + msg);
		       console.log('file: ' + file);
		       console.log('column: ' + column);
		       console.log('line: ' + line);
		       console.log('err: ' + err);
		       console.log('data:' + data);
		   });
	}
	return false;
    };
}

function sticky_control(table_name, page_name) {
  window.onscroll = function() { stickyAdd(); };
  var wrap_ActionArea = document.getElementById("wrap-ActionArea");
  var target = document.getElementById(table_name);
  const footer = $('footer');
  $('#ActionArea').css('margin-left','0');
  $('.modal').on('show.bs.modal', function(){
      setTimeout(function(){
          $('#wrap-ActionArea').css('z-index', '10');
      });
  });

  $('.modal').on('hidden.bs.modal', function(){
      if($('.modal:visible').length === 0){
          $(wrap_ActionArea).css('z-index', '1045');
      }else{
          $(wrap_ActionArea).css('z-index', '500');
      }
  });

  function stickyAdd() {
      var calc_offset = function(){
                            var offset = 0;
                            if(page_name === 'hosts' || page_name === 'host' || page_name === 'vulnerability' || page_name === 'rule'|| page_name === 'lproducts' || page_name === 'products' || page_name === 'local_vuls'){
                                var SummaryT  = document.getElementById('SummaryTable');
                                var SummaryTdynamic = SummaryT.offsetTop;
                                var SummaryTHeight= document.getElementById('SummaryTable').clientHeight;
                                offset = SummaryTdynamic + SummaryTHeight;
                             }else if(page_name === 'vulnerabilities'){
                                 var SummaryT  = document.getElementById('SummaryTable');
                                 var SummaryStaticOffset = SummaryT.offsetTop;
                                 var SummaryTHeight= document.getElementById('SummaryTable').clientHeight;
                                 var accordion1_h  = document.getElementById('system_category_table').clientHeight;
                                 var accordion2_h  = document.getElementById('OS_distributions').clientHeight;
                                 var accord_h = accordion1_h + accordion2_h;
                                 offset = SummaryStaticOffset + accord_h + SummaryTHeight;
                             }else if(page_name ==='users' || page_name === 'licence' || page_name === 'histories'){
                                 var clientRect = target.getBoundingClientRect();
                                 offset = clientRect.top; 
                             }
                             return offset;
                         };
      if (window.pageYOffset >= calc_offset()) {
           if( $(wrap_ActionArea).find('footer').length === 0){
               $(wrap_ActionArea).append(footer);
           }
           $('#hidden-space').height($('#wrap-ActionArea').height());
           wrap_ActionArea.classList.add('sticky');
      } else {
          $('#hidden-space').height('0');
          wrap_ActionArea.classList.remove('sticky');
      }
  }
}

//アクションボタンとフィルターのdropdownがあるページで使用する。
//modalを開いた後にフィルターボタンを押下すると、
//アクションボタンと被る部分が表示されないため、この処理を入れる
function set_style_for_ActionArea_on_filter_dropdown_event(){
    $('.summary-filter-buttons [data-toggle="dropdown"]').parent().on('show.bs.dropdown', function(){
        $('#wrap-ActionArea').css('z-index', 10);
    });
    $('.summary-filter-buttons [data-toggle="dropdown"]').parent().on('hidden.bs.dropdown', function(){
        $('#wrap-ActionArea').css('z-index', 1045);
    });
}

function set_scroll(){
    var ScrollTable = $('[data-outertable="scroll"]');
    var inner_table = $('[data-innertable="scroll"]');
    var ScrollTable_offset = ScrollTable.offset().top;
    var MainContainer_bottom = parseInt($('#MainContainer').css('padding-bottom').replace('px', ''));
    var space_for_scroll =  (MainContainer_bottom > 0 ? MainContainer_bottom : 35)
                            + parseInt($('#ActionArea').css('padding').replace('px', ''))
                            ;
    var doc_height = $(document).innerHeight();
    var window_height = $(window).innerHeight();
    var scrolled_quantity = $(window).scrollTop();
    var bottom_height = $('#wrap-ActionArea').hasClass('sticky') ?
                        ($('#wrap-ActionArea').outerHeight(true)
                         - ($('#pagenationArea').outerHeight(true) + space_for_scroll))
                         :
                         ($('#ActionArea').outerHeight(true) + $('footer').outerHeight(true)
                         + $('#pagenationArea').outerHeight(true))
                         ;
    if((doc_height - window_height) > (scrolled_quantity + bottom_height) 
         && ((ScrollTable_offset - window_height + 15) < scrolled_quantity)
         && (ScrollTable.width() < ScrollTable.get(0).scrollWidth)
         && ($('#floating-scroll').length === 0)){
         var dummy_scroll = $('<div>')
                            .attr('id', 'floating-scroll')
                            .css({
                                 'left': ScrollTable.offset().left,
                                 'bottom': $('#wrap-ActionArea').hasClass('sticky') ? $('#wrap-ActionArea').height() : 0
                                 });
         var inner_dummy_scroll = $('<div>')
                                   .attr('id', 'inner-floating-scroll')
                                   .css({
                                       'height':'20px',
                                       'z-index':'1060'
                                       });
         dummy_scroll.append(inner_dummy_scroll);
         $('#content-block').append(dummy_scroll);
         dummy_scroll.on('scroll', function(){
             ScrollTable.get(0).scrollLeft = dummy_scroll.get(0).scrollLeft;
         });
    }
    setTimeout(function(){
      //ここだけ非同期にしないと、
      //フッターの表示・非表示の切り替え時にフッターがある時の位置に
      //#floating-scrollが残ってしまう時がある。
        if(!$('#wrap-ActionArea').hasClass('sticky')){
            $('#floating-scroll').css('bottom', '0');
        }else{
            $('#floating-scroll').css('bottom',  $('#wrap-ActionArea').height());
        }
    },);
    if((doc_height - window_height) > (scrolled_quantity + bottom_height) 
        && ((ScrollTable_offset - window_height + 15) < scrolled_quantity)){
        $('#floating-scroll').show();
    }else{
        $('#floating-scroll').hide();
    }
    $('#floating-scroll').offset({'left':ScrollTable.offset().left});
    $('#floating-scroll').width(ScrollTable.width());
    $('#inner-floating-scroll').width(inner_table.width());
    
    $('.modal').on('show.bs.modal', function(){
        $('#floating-scroll').css('z-index', '10');
    });
    $('.modal').on('hidden.bs.modal', function(){ 
        if($('[data-slidemodal]').length === 0){
            $('#floating-scroll').css('z-index', '1060');
        }else{
            $('#floating-scroll').css('z-index', '10');
        }
    });
}

//ステータス一括変更をprogress barを使って表示
function execute_process_with_progress_bar(target, conf_message, info, path){
    if( conf_message && conf_message.length > 0 ){
        var conf = confirm(conf_message);
        if( !conf ){
            return false;
        }
    }
    var ids = JSON.stringify(info['ids']);
    var action = info['action'];
    var comment = info['comment'];
    if( target === 'status' ){
        var prev_status = info['prev_status'];
        var new_status = info['new_status'];
    }else{
        var force = String(info['force']);
        var due_date = info['due_date'];
    }
    var percentage = 0;
    var total_vuls_size;
    var total_executed_vuls_size = 0;
    var shift_num;
    var err_message = '';
    var issue_ids = [];
    if( target === 'status' ){
        if( new_status == 0 ){
            alert('変更後のステータスを選択して下さい');
            return false;
        }
        if( prev_status == new_status ){
            alert('変更前と変更後のステータスが同じです');
            return false;
        }
    }
    var progress = $('<div>').attr('class', 'progress-area').append(
        $('<div>').attr('class', 'progress-area-label').text('処理実行中...'),
        $('<div>').attr('class', 'progress').append(
            $('<div>').attr({
                'id': 'progress-bar',
                'class': 'progress-bar progress-bar-striped',
                'role': 'progressbar',
                'aria-valuenow': '0',
                'aria-valuemin': '0',
                'aria-valuemax': '100'
            }).text('0%')
        )
    );
    var wrap_progress = $('<div>').attr('class', 'position-relative h-100 w-100').append(progress);
    var progress_window = $('<div>').attr('class', 'progress-window').append(progress);
    $('body').append(progress_window);
   
    var executed_vuls_size = 0;
    function exec_bulk_partial_update(target) {
        if( target === 'status' ){
            d = {
                issue_ids: JSON.stringify(issue_ids),
                shift_num: shift_num,
                ids: ids,
                prev_status: prev_status,
                new_status: new_status,
                comment: comment,
                action_name: action
            };
        }else{
            d = {
                issue_ids: JSON.stringify(issue_ids),
                shift_num: shift_num,
                ids: ids,
                force: force,
                due_date: due_date,
                comment: comment,
                action_name: action
            };
        }
        $.ajax({
            url: path,
            type: 'POST',
            data: d,
        }).done(function(data){
            executed_vuls_size = data['executed_vuls_size'];
            if( data['total_size'] != null){
                total_vuls_size = data['total_size'];
            }
            if( data['shift_num'] ){
                shift_num = data['shift_num'];
            }
            issue_ids = data['issue_ids'];
            if( data['err'] ){
                if( data['err'] == 'invalid' ){
                    err_message = '不正な操作です。';
                }else if( data['err'] = 'db_error' ){
                    err_message = total_vuls_size + '件中のうち、' + total_executed_vuls_size + '件の処理が完了し、' +
                                  data['err_vuls_size'] + '件でエラーが発生しました。\n' +
                                  (total_vuls_size - total_executed_vuls_size) + '件は未処理となっています。';
                }
            }

            if(err_message.length > 0){
                 alert(err_message);
                 $('#pages_checked').val('[]');
                 $('#pages_all_checked').val('');
                 $('#pages_form').submit();
                 return false;
            }else if(total_vuls_size === 0){
                 if( target === 'status' ){
                     alert('変更の対象となるデータがありませんでした。画面をリロードします。');
                 }else{
                     alert('変更の対象となるデータがありませんでした。画面をリロードします。\n※全てのデータに対策予定日が設定されている可能性があります。対策予定日が設定されているデータは、「強制上書き」にチェックを入れないと、変更の対象となりません。\n※また、対応状況が「対策済」と「影響無」のデータも変更の対象となりませんので、ご注意ください。');
                }
                $('#progress-bar').attr('aria-valuenow', '0').css('width', '').text('0%');
                $('#pages_checked').val('[]');
                $('#pages_all_checked').val('');
                $('#pages_form').submit();
                return false;
            }
            total_executed_vuls_size += executed_vuls_size;
            percentage = (total_executed_vuls_size / total_vuls_size) * 100;
            if( percentage >= 99 && percentage < 100 ){
                percentage = 99;
            }else{
                percentage = Math.round(percentage);
            }
            $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
            if( percentage === 100 ){
                setTimeout(function(){//probress barのbarが満たされるまで待つ
                    $('#pages_checked').val('[]');
                    $('#pages_all_checked').val('');
                    if( action && action === 'single' ){
                        $('#pages_form').append($('<input>').attr({'type': 'hidden', 'name': 'pages[is_update_one_row]'}).val('true'));
                    }
                    $('#pages_form').submit();
                },800);
            }else{
                exec_bulk_partial_update(target);
            }
        });
     }
     exec_bulk_partial_update(target);
}

var jqxhr_for_list = null
//ホスト名・カテゴリ名を表示するバルーンの表示
function enable_dropdown_balloon(){
    $('.create-balloon').on('click', function(){
        var trigger_btn = $(this);
        var trigger_parent = trigger_btn.closest('.balloon-dropdown');
        var max_width = trigger_parent.find('.balloon-menu').css('max-width').replace('px', '');
        var is_space_of_right = $(window).width() - (trigger_btn.offset().left + trigger_btn.outerWidth()) > max_width;
        trigger_parent.removeClass('dropright dropleft').addClass(is_space_of_right ? 'dropright' : 'dropleft');
        trigger_parent.removeClass('balloon-right balloon-left')
            .addClass(is_space_of_right ? 'balloon-right' : 'balloon-left');
        trigger_btn.attr({
            'data-toggle': 'dropdown',
            'data-boundary': 'window',
            'aria-haspopup': 'true',
            'aria-expanded': 'false',
            'data-flip': 'false',
        }).dropdown();
    });

}

//ホストが多い場合にhtmlの表示に時間がかかる可能性があるため、ajaxを使って表示する
function enable_hosts_list_balloon(){
    $('.create-hosts-list-ballon').on('click', function(){
        var path = $('#sidfm_internal_api_get_vul_hosts_path').val();
        var trigger_btn = $(this);
        var html_id = trigger_btn.data('htmlid');
        var trigger_parent = trigger_btn.closest('.balloon-dropdown');
        if( !$('#hosts-list-' + html_id).is(':visible') ){
            var max_width = trigger_parent.find('.balloon-menu').css('max-width').replace('px', '');
            var is_space_of_right = $(window).width() - (trigger_btn.offset().left + trigger_btn.outerWidth()) > max_width;
            trigger_parent.removeClass('dropright dropleft').addClass(is_space_of_right ? 'dropright' : 'dropleft');
            trigger_parent.removeClass('balloon-right balloon-left')
                          .addClass(is_space_of_right ? 'balloon-right' : 'balloon-left');
            if( jqxhr_for_list ){
                jqxhr_for_list.abort();
            }
            jqxhr_for_list = $.post(
                path,
                { 'html_id': html_id },
                function(data){
                    var hosts = data['hosts'];
                    var htmlid = data['html_id'];
                    if( hosts.length === 0 ){
                        alert('ホストが削除されたか、ユーザもしくはホストのカテゴリが変更されているため、 画面をリロードします。')
                        $('#pages_checked').val('[]');
                        $('#pages_all_checked').val('false');
                        $('#pages_form').submit(); 
                    }
                    var target = $('#hosts-list-' + htmlid);
                    $('#hosts-size-' + htmlid).text(hosts.length);
                    $('#hosts-first-' + htmlid).text(hosts[0]['display_name']);
                    target.html('');
                    var append_host_elm = function(host){
                        var host_id = host['sidfmd_host_id'];
                        var host_elm = $('<div>').attr({
                            'class': 'host-list-item list-group-item text-truncate g-max-width-12em'
                        }).append(
                            $('<span>').attr({
                                'data-toggle': 'tooltip',
                                'data-placement': 'right',
                                'data-boundary': 'window',
                                'data-html': 'true',
                                'title': 'ホスト名: ' + host['hostname'] + '<br/>表示名: ' + (host['ext_name'] ? host['ext_name'] : '(未設定)'),
                            }).append(
                                $('<a>').attr({
                                    'href': url_host_detail(host_id)    
                                }).text(host['display_name'])
                            )
                        );
                        target.append(host_elm);
                        target.find('[data-toggle=tooltip]').tooltip();
                    };
                    hosts.slice(0, 15).forEach(function(host){//すぐに表示させるために先に15件要素を作成
                        append_host_elm(host);
                    });
                    trigger_btn.attr({
                        'data-toggle': 'dropdown',
                        'data-boundary': 'window',
                        'aria-haspopup': 'true',
                        'aria-expanded': 'false',
                        'data-flip': 'false',
                    }).dropdown();
                    if( !$('#hosts-list-' + html_id).is(':visible') ){
                        //bootstrapでclickイベントを見ているのか、
                        //dropdown.('show')にするとdropdown-menuがテーブルの内側に表示され、
                        //dropdown-menuが見えなくなるため、
                        //click()で表示する
                        //(data-boundary="window"が効かない状態になるのを防ぐ)
                        trigger_btn.click();
                    }
                    trigger_btn.parent().find('.dropdown-menu').css('z-index', 1500);
                    setTimeout(function(){
                        hosts.slice(15).forEach(function(host){
                            append_host_elm(host);//残りを作成    
                        });
                    });
                }
            );
        }
    });
}

//カテゴリが多い場合にもhtmlの表示に時間がかかる可能性があるため、ajaxを使って表示する
function enable_categories_list_balloon(page_name){
    $('.create-categories-list-balloon').on('click', function(){
        var path = $('#sidfm_internal_api_get_hosts_vuls_related_categories_path').val();
        var trigger_btn = $(this);
        var html_id = trigger_btn.data('htmlid');
        var host_id = trigger_btn.data('hostid');
        var trigger_parent = trigger_btn.closest('.balloon-dropdown');
        var max_width = trigger_parent.find('.balloon-menu').css('max-width').replace('px', '');
        var is_space_of_right = $(window).width() - (trigger_btn.offset().left + trigger_btn.outerWidth()) > max_width;
        trigger_parent.removeClass('dropright dropleft').addClass(is_space_of_right ? 'dropright' : 'dropleft');
        trigger_parent.removeClass('balloon-right balloon-left')
                      .addClass(is_space_of_right ? 'balloon-right' : 'balloon-left');
        var is_append_needed = false;
        if( (html_id && !$('#categories-list-' + html_id).is(':visible')) ||
            (host_id && !$('#categories-list-' + host_id).is(':visible')) ){
            is_append_needed = true;
        }
        if( is_append_needed ){
            if( jqxhr_for_list ){
                jqxhr_for_list.abort();
            }
            jqxhr_for_list = $.post(
                path,
                { 'html_id': html_id, 'host_id': host_id, 'page_name': page_name },
                function(data){
                    var categories = data['categories'];
                    if( categories.length === 0 ){
                        alert('データが変更されているため、画面をリロードします。')
                        $('#pages_checked').val('[]');
                        $('#pages_all_checked').val('false');
                        $('#pages_form').submit();
                    }
                    var htmlid = data['html_id'];
                    var hostid = data['host_id'];
                    var is_bind_needed = false;
                    var target_id = hostid ? hostid : htmlid; //脆弱性詳細ではhtmlidとhostidの両方があり、hostidがある要素が対象のため、hostidを先に評価する
                    var target = $('#categories-list-' + target_id);
                    target.html('');
                    $('#categories-size-' + target_id).text(categories.length);
                    $('#categories-first-' + target_id).text(categories[0]['system_category_name']);
                    if( target ){
                        var append_category_elm = function(category){
                            target.append(
                                $('<a>').attr({
                                    'class': 'categories-list-item list-group-item text-truncate g-max-width-16em',
                                    'href': category['url'],
                                    'data-toggle': 'tooltip',
                                    'data-title': category['desc'],
                                    'data-placement': 'right',
                                    'data-boundary': 'window'
                                }).text(category['system_category_name'] ? category['system_category_name'] : category['custom_category_name'])
                            );
                        };
                        categories.slice(0, 15).forEach(function(category){//すぐに表示されるように先に15件要素を作成
                            append_category_elm(category);
                        });
                        target.find('a').tooltip();
                        trigger_btn.attr({
                            'data-toggle': 'dropdown',
                            'data-boundary': 'window',
                            'aria-haspopup': 'true',
                            'aria-expanded': 'false',
                            'data-flip': 'false',
                        }).dropdown()
                        if( !target.is(':visible') ){
                            trigger_btn.click();
                        }
                        trigger_btn.parent().find('.dropdown-menu').css('z-index', 1500);
                        setTimeout(function(){
                            categories.slice(15).forEach(function(category){//残りを作成
                                append_category_elm(category);
                            });
                            target.find('a').tooltip();
                        });
                    }
                }
            );
         
        } 
    }); 
}

//progress_barを作成
function get_progress_bar(method_type = 'post'){
    var progress = $('<div>').attr('class', 'progress-area').append(
        $('<div>').attr({'class': 'progress-area-label', 'id': 'progress-bar-label'}).text('処理実行中...'),
        $('<div>').attr('class', 'progress').append(
            $('<div>').attr({
                'id': 'progress-bar',
                'class': 'progress-bar progress-bar-striped' + (method_type === 'get' ? ' bg-success' : ''),
                'role': 'progressbar',
                'aria-valuenow': '0',
                'aria-valuemin': '0',
                'aria-valuemax': '100'
            }).text('0%')
        )
    );
    var progress_window = $('<div>').attr({'id': 'progress-window', 'class': 'progress-window'}).append(progress);
    return progress_window
}

//HostView, VulViewのupdate
function update_view(host_ids = [], html_ids = [], is_appended = false){
    if( host_ids.length > 0 || html_ids.length > 0 ){
        if( !is_appended ){
            var progress_window = get_progress_bar();
            $('body').append(progress_window);
        }
        var path = $('#sidfm_internal_api_update_view_path').val();
        var total_size = host_ids.length + html_ids.length;
        var executed_size = 0;
        var execute_update_view = function(){
            $.ajax({
                type: 'POST',
                url: path,
                data: { 'host_ids': JSON.stringify(host_ids), 'html_ids': JSON.stringify(html_ids) }
            }).done(function(data){
                if( data['executed_size'] === 0 ){
                    if( $('#pages_form').length > 0 ){
                        setTimeout(function(){//progress barが満たされるまで待つ
                            $('#pages_checked').val('[]');
                            $('#pages_all_checked').val('false');
                            $('#pages_form').submit();
                        },500);
                    }else{
                        location.reload();
                    }
                }else{
                    host_ids = data['unexecuted_host_ids'];
                    html_ids = data['unexecuted_html_ids'];
                    executed_size += data['executed_size'];
                    var percentage = (executed_size / total_size * 100);
                    if( percentage >= 99 && percentage < 100 ){
                        percentage = 99;
                    }else{
                        percentage = Math.round(percentage);
                    }
                    $('#progress-bar').attr('aria-valuenow', percentage)
                                      .css('width', percentage + '%')
                                      .text(percentage + '%');
                    execute_update_view();
                }
            });
        };

        execute_update_view();
    }else{
        if( $('#pages_form').length > 0 ){
            $('#pages_checked').val('[]');
            $('#pages_all_checked').val('false');
            $('#pages_form').submit();
        }else{
            location.reload();
        }
    }
}

//cvsswをクリックした時にCVE IDの一覧を表示する
function enable_display_cve_ids(){
    function arrange_cvss_list_position(button, list_elm){
        if( !button ){
            button = $('.show-summary-cves[data-vulid="' + list_elm.attr('data-vulid') + '"]');
        }
        var offset = button.offset();
        list_elm.offset({
            'top': offset.top - 5, 
            'left': offset.left + button.outerWidth()
        }).show();
        $('[data-toggle="dropdown"]').dropdown();
    }

    function create_summary_cve_info_list(button, vul_id, cves){
        $('.summary-cveinfo-list').remove();//表示するのは１つのみ
        $('[data-toggle="dropdown"]').parent().dropdown('hide');
        var list_elm = $('<div>').attr({
            'class': 'summary-cveinfo-list',
            'data-vulid': vul_id
        });
        var content = $('<div>').attr('class', 'summary-cveids-list');
        content.append(
            $('<div>').attr('class', 'summary-cveids-list-title').text('CVE ID 一覧')//.text(cve_info['time'])//'CVE ID 一覧')
        );

        var cvss_v2_vectors = JSON.parse($('#cvss-v2-vectors').val());
        var cvss_v3_vectors = JSON.parse($('#cvss-v3-vectors').val());

        cves = cves.map(function(cve) {
            var display_cvss = '';
            var cvss_v3 = cve['cvss_v3'];
            if( cvss_v3 ){
                var cvss_text_elms = [];
                for( key in cvss_v3 ) {
                    var value = cvss_v3[key];
                    var target_item = cvss_v3_vectors[key];
                    var item_name = target_item['item_name'];
                    var value_name = target_item['values'][value];
                    cvss_text_elms.push(item_name + ': ' + value_name);
                }
                display_cvss += '<div class="summary-cvss-vs-title">CVSS V3</div>' +
                                '<div>' + cvss_text_elms.join('<br>') + '</div>';
            }

            var cvss_v2 = cve['cvss_v2'];
            if ( cvss_v2 ){
                var cvss_text_elms = [];
                for( key in cvss_v2 ) {
                    var value = cvss_v2[key];
                    var target_item = cvss_v2_vectors[key];
                    var item_name = target_item['item_name'];
                    var value_name = target_item['values'][value];
                    cvss_text_elms.push(item_name + ': ' + value_name);
                }
                display_cvss += '<div class="summary-cvss-vs-title">CVSS V2</div>' + 
                                '<div class="mb-1">' + cvss_text_elms.join('<br>') + '</div>';
            }

            return $('<div>').attr('class', 'd-flex summary-cve-item').append(
                       $('<div>').attr({
                           'class': 'summary-cveid'
                       }).text(cve['cve_id']),
                       $('<div>').attr({
                           'class': 'summary-cvss-vectors-area',
                       }).append(
                           $('<button>').attr({
                               'type': 'button',
                               'class': 'btn btn-xs summary-cvss-vectors-btn',
                               'data-toggle': 'tooltip',
                               'data-title': display_cvss.length > 0 ? display_cvss : '未登録',
                               'data-placement': 'right',
                               'data-html': 'true',
                               'data-boundary': 'window'
                           }).text('CVSS指標')
                       )
                   );
        });
        content.append(
            $('<div>').attr({
                'id': 'summary-cveids-list-body-' + vul_id,
                'class': 'summary-cveids-list-body',
            }).append(cves),
            $('<div>').attr('class', 'd-flex').append(
                $('<button>').attr({
                    'type': 'button',
                    'class': 'btn btn-primary ml-auto copybtn summary-cveids-list-copybtn copy-cveids-list',
                    'data-toggle': 'tooltip',
                    'data-title': 'コピーしました!',
                    'data-trigger': 'manual'
                }).text('コピー')//ClipboardJSでコピー。コピーの実装は各ページによって異なるため、各ページのjsで行う
            )
        );
        $('body').append(list_elm.append(content).hide());
        list_elm.find('[data-toggle="tooltip"]').tooltip();
        arrange_cvss_list_position(button, list_elm);
    }

    $(window).on('scroll resize', function(){
        $('.summary-cveinfo-list [data-toggle="tooltip"]').tooltip('hide');
        $('.summary-cveinfo-list').remove();
    });

    $(document).on('click', function(e){
        if( e.target ){
            var t_elm = $(e.target);
            if( !t_elm.hasClass('show-summary-cves') && !t_elm.hasClass('show-summary-cves-inner') && !t_elm.hasClass('copy-cveids-list') ){
                $('.summary-cveinfo-list [data-toggle="tooltip"]').tooltip('hide');
                $('.summary-cveinfo-list').remove();
            }
        }
    });

    $(document).on('mousedown', '[data-outertable], #floating-scroll', function(e){
        if( e.target ){
            if( !$(e.target).hasClass('show-summary-cves') && !$(e.target).hasClass('show-summary-cves-inner')){
                $('.summary-cveinfo-list [data-toggle="tooltip"]').tooltip('hide');
                $('.summary-cveinfo-list').remove();
            }
        }
    });
    
    $('[data-toggle="dropdown"]').parent().on('show.bs.dropdown', function(){
        $('.summary-cveinfo-list [data-toggle="tooltip"]').tooltip('hide'); 
        $('.summary-cveinfo-list').remove();
    });

    $('.filter-buttons-area .dropdown-menu').on('click', function(e){
        e.stopPropagation();
    });

    $('.show-summary-cves, .show-summary-cves-inner').on('mousedown', function(e){
        var button = $(this);
        if( button.hasClass('no-cves') ){
            return false;
        }
        if( button.hasClass('show-summary-cves-inner') ){
            button = button.closest('.show-summary-cves');
        }
        e.stopPropagation();
        var id = button.attr('data-vulid');
        var target = $('.summary-cveinfo-list[data-vulid="' + id + '"]');
        $('.summary-cveinfo-list [data-toggle="tooltip"]').tooltip('hide');
        if( target.length > 0 ){
            target.remove();
        }else{
            if( button.attr('data-getdata') ) {
                if( button.data('pagename') === 'host' ){
                    var path = $('#get_vul_view_cve_info_of_host_path').val();
                    var param = { 'html_id': id, 'host_id': $('#host_id').val() };
                }else{
                    var path = $('#sidfm_internal_api_get_vul_view_cve_info_path').val();
                    var param = { 'vul_id': id };
                }
                $.post(path, param, function(data){
                    if( data['err'] ){
                        alert('データが変更されている、もしくはデータの取得に失敗しました。画面をリロードします。');
                        location.reload(true);
                    }
                    create_summary_cve_info_list(button, id, data['cves']);
                });
            }else{
                var cves = JSON.parse(button.attr('data-cves'));
                create_summary_cve_info_list(button, id, cves);
            }
            
        }
    });
}


//JSON/TSVのプログレスバーを使ったサマリー表のデータダウンロード中止
function cancel_json_tsv_download(message){
    alert(message + '画面をリロードします。');
    //$('#pages_checked').val('[]');
    //$('#pages_all_checked').val('false');
    $('#pages_form').submit();
}

//JSON/TSVのプログレスバーを使ったサマリー表のデータダウンロード
function json_tsv_summary_table_progress_download(target_format, path, limit){
    var conf = confirm('ファイルをダウンロードします');
    if( !conf ){
        return false;
    }
    var progress_window = get_progress_bar('get');
    progress_window.find('#progress-bar-label').text('お待ちください...');
    $('body').append(progress_window);
    var order = $('#pages_order').val();
    var filters = $('#pages_filters').val();
    var executed_size = 0;
    var total_size = 0;
    var percentage = 0;
    var ids = JSON.parse($('#pages_checked').val());
    var process = 'init';
    var read_data = function(){
        $.ajax({
            url: path,
            type: 'POST',
            data: {
                'target': target_format,
                'ids': JSON.stringify(ids),
                'executed_size': executed_size,
                'process': process,
                'order': order,
                'filters': filters
            }
        }).done(function(res){
            //console.log(res)
            if( res.err_message && res.err_message.length > 0 ){
                cancel_json_tsv_download(res.err_message);
            }else{
                if( process === 'init' ){
                    if( res.ids.length > res.max_download_size ){
                        var conf = confirm('ダウンロード可能な最大件数を超えていますが、最大件数まではダウンロード可能です。 \nダウンロードしますか?');
                        if( conf ){
                            res.ids = res.ids.slice(0, res.max_download_size)
                        }else{
                            $('#progress-window').remove();
                            return false;
                        }
                    }
                    $('#progress-bar-label').text('処理実行中...');
                    //始めの応答ではデータ数を取得し、processを書き換える。
                    total_size = res.ids.length;
                    process = 'progress_download';
                }
                if( res.ids.length > 0 ){
                    executed_size = res.executed_size;
                    ids = res.ids;
                    percentage = (executed_size / total_size * 100);
                    if( percentage >= 99 && percentage < 100 ){
                         percentage = 99;
                    }else{
                         percentage = Math.round(percentage);
                    }
                    $('#progress-bar').attr('aria-valuenow', percentage).css('width', (percentage < 3 ? 3 : percentage) + '%').text(percentage + '%');
                    read_data();
                }else{
                    percentage = 100;
                    $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                    $('#form-download').submit();
                    $('#progress-bar-label').text('ファイル送信中...');
                    var timer = setInterval(function(){
                        if( $.cookie('export_flg') ){
                            setTimeout(function(){//probress barのbarが満たされるまで待つ
                                $.cookie('export_flg',"",{path:"/",expires:-1});
                                $('#progress-window').remove();
                            },500);
                            clearInterval(timer);
                        }
                    },10);
                }
            }
        }).fail(function(){
            cancel_json_tsv_download('ファイルのダウンロードに失敗しました。');
        });
    };

    read_data();
}

//pages_checked, pages_all_checkedのリセット
function reset_pages_checked_values(){
    $('#pages_all_checked').val('');
    $('#pages_checked').val(JSON.stringify([]));
}

function sanitize_string(str){
    return str.replace(/\\/g, '\\\\').replace(/'/g, '\\\'');
}

function escape_html_special_chars(str){
    return str.replace(/\"/g, '&quot;').replace(/\'/g, '&#39;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
}
