/* coding: utf-8 */
/* Copyright (C) 2021 Softek Systems. Inc. */

//履歴情報画面

$(function(){
    init_paginator();
    sticky_control('SummaryTable', 'histories');
    activate_sidebar_item('sidebar-item-history-manip');
    set_style_for_ActionArea_on_filter_dropdown_event();
 
    setTimeout(function(){
        set_scroll();
        $(window).on('resize scroll', set_scroll);
    },200);

    //フィルタ
    function execute_filter(filters){
        reset_pages_checked_values(); 
        $('#pages_filters').val(JSON.stringify(filters));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
        return false;
    }

    //dropdownのメニュー内をクリックした時にダイアログが閉じてしまうのを防ぐ
    $('.filter-item').on('click', function(e){
        e.stopPropagation();
    });
 
    //権限検索
    $('#exec-filter-roles').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        var ids = [];
        $('#filter-roles-menu .role-select:checked').each(function(){
            ids.push(parseInt($(this).val()));
        });
        if( ids.length == 0 ){
            alert('権限を1つ以上チェックして下さい');
            return false;
        }
        filters['roles']['ids'] = ids;
        filters['roles']['is_except'] = $('#filter-roles-is-except-check-box').prop('checked');
        execute_filter(filters);
        return false;
    });

    $('#reset-filter-roles').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['roles']['ids'] = [];
        filters['roles']['is_except'] = false;
        execute_filter(filters);
    });

    //ユーザ・カテゴリ検索
    function create_filter_searched_elm(data, is_add, ids, target_item_name){
        var btn_class = '';
        var btn_text = '';
        if( is_add ){
            if( ids.includes(data.id) ){
                btn_class = 'btn-success';
                btn_text = '選択済';
            }else{
                btn_class = 'select btn-primary';
                btn_text = '選択';
            } 
        }else{
            btn_class = 'delete btn-danger';
            btn_text = '削除';
        }
        var btn = $('<button>').attr({
                      'type': 'button',
                      'class': 'text-nowrap toggle-select btn btn-sm ' +  btn_class,
                      'data-info': JSON.stringify(data),
                      'data-id': data.id,
                      'data-itemname': target_item_name
                  }).text(btn_text)
        var tr = $('<tr>').attr('class', 'item-row');
        if( target_item_name === 'users' ){
            tr.append(
                $('<td>').attr({ 'class': 'login' }).append(
                    $('<div>').text(data.login),
                ),
                $('<td>').attr({ 'class': 'name' }).append(
                    $('<div>').text(data.lastname + ' ' + data.firstname),
                ),
                $('<td>').attr({ 'class': 'email' }).append(
                    $('<div>').text(data.address),
                ),
                $('<td>').attr({ 'class': 'ope' }).append(
                    $('<div>').append(btn)
                )
            );
         }else if( target_item_name === 'hosts' ){
             tr.append(
                 $('<td>').attr({ 'class': 'hostname'}).append(
                    $('<div>').attr({ 
                        'data-toggle': 'tooltip', 
                        'data-title': 'ホスト名: ' + data.hostname + '<br/>表示名: ' + (data.ext_name ? data.ext_name : '(未設定)'),
                        'data-html': 'true',
                        'data-placement': 'left'
                    }).text(data.ext_name ? data.ext_name : data.hostname)
                ),
                $('<td>').append(
                    $('<div>').attr({ 'class': 'ope' }).append(btn)
                )   
             );
         }
         return tr;
    }

    function bind_filter_selected_elm(element){
        element.find('.delete').on('click', function(){
            var item_name = $(this).data('itemname');
            var param = JSON.parse($('#filter-' + item_name + '-param').val());
            var id = $(this).data('id');
            param.ids = param.ids.filter(function(selected_id){
                return id != selected_id;
            });
            $('#filter-' + item_name + '-param').val(JSON.stringify(param));
            $(this).closest('.item-row').remove();
            var target_elm = $('#filter-' + item_name + '-searched-list [data-id="' + id + '"]')
            if( target_elm.length > 0 ){
                target_elm.addClass('select btn-primary')
                          .removeClass('btn-success').text('選択');
                bind_filter_searched_elms(item_name, target_elm);
            }
            check_is_filter_selected_elm(item_name);
        });
    }

    function bind_filter_searched_elms(item_name, element){
        if( element ){
            var target = element
            target.unbind();
        }else{
            var target = $('#filter-' + item_name + '-searched-list .select');
        }
        target.on('click', function(){
            var item_name = $(this).data('itemname');
            var param = JSON.parse($('#filter-' + item_name + '-param').val());
            var id = $(this).data('id');
            if( param.ids.includes(id) ){
                return false;
            }
            param.ids.push(id);
            $('#filter-' + item_name + '-param').val(JSON.stringify(param));
            var data = JSON.parse($(this).attr('data-info'));
            append_selected_elm(data, param, item_name);
            $(this).removeClass('select btn-primary').addClass('btn-success').text('選択済');
            check_is_filter_selected_elm(item_name);
        });
    }

    function check_is_filter_selected_elm(item_name){
        var search_btn = $('.filter-modal[data-itemname="' + item_name + '"] [data-execute="search"]');
        var param = JSON.parse($('#filter-' + item_name + '-param').val());
        if( param.ids.length === 0 ){
            if( $('#no-selected-' + item_name + '-message').length === 0 ){
                $('#search-' + item_name + '-modal-body').append(
                    $('<tr>').attr('id', 'no-selected-' + item_name + '-message').append(
                        $('<td>').attr({
                            'colspan': 4,
                            'class': 'text-danger text-center bg-white',
                        }).text('下の欄から検索して下さい')
                    )
                );
            }
            if( item_name === 'users' ){
                if( $('#filter-users-is-except-anonymous-checkbox').prop('checked') ){
                    search_btn.prop('disabled', false);
                }else{
                    search_btn.prop('disabled', true);
                }
            }else{
                search_btn.prop('disabled', true);
            }
        }else{
            $('#no-selected-' + item_name + '-message').remove();
            search_btn.prop('disabled', false);
        }
    }

    var jqxhr = null;
    function search_data_for_filter(target_item_name){
        var searched_list = $('#filter-' + target_item_name + '-searched-list-area');
        var searched_list_body = $('#filter-' + target_item_name + '-searched-list-body');
        searched_list_body.html('');
        $('#filter-' + target_item_name + '-searched-list').scrollTop(0);
        $('#search-filter-' + target_item_name + '-input-area').tooltip('hide');
        var input_val = $('#search-filter-' + target_item_name + '-input').val();
        if( input_val != '' ){
            if( jqxhr ){
                jqxhr.abort();
            }
            var path = $('#get-filter-data-path').val();
            var item = $('#filter-' + target_item_name + '-search-item-select').val();
            var param = JSON.parse($('#filter-' + target_item_name + '-param').val());
            jqxhr = $.post( path, { 'str': input_val, 'item': item, 'filter_item': target_item_name }, function(items){
                var elms = items.map(function(data){
                    return create_filter_searched_elm(data, true, param.ids, target_item_name);
                });
                if( elms.length === 0 ){
                    searched_list_body.html('');
                    searched_list.hide();
                    $('#search-filter-' + target_item_name + '-input-area').tooltip('show');
                }else{
                    searched_list_body.append(elms);
                    bind_filter_searched_elms(target_item_name);
                    searched_list.show();
                    $('#search-filter-' + target_item_name + '-input-area').tooltip('hide');
                    if( target_item_name === 'hosts' ){
                        searched_list_body.find('[data-toggle="tooltip"]').tooltip();
                    }
                }
                check_is_filter_selected_elm(target_item_name);
            });
        }else{
            searched_list.hide();
        }
    }

    function append_selected_elm(data, parameter, item_name){
        var elm = create_filter_searched_elm(data, false, parameter.ids, item_name);
        $('#search-' + item_name + '-modal-body').append(elm);
        bind_filter_selected_elm(elm);
        if( item_name === 'hosts' ){
            $('#search-' + item_name + '-modal-body [data-toggle="tooltip"]').tooltip();
        }
    }

    function open_filter_modal(target_item_name){
        $('#filter-' + target_item_name + '-searched-list-area').hide();
        $('#filter-' + target_item_name + '-param').val($('#original-filter-' + target_item_name + '-param').val());
        var param = JSON.parse($('#filter-' + target_item_name + '-param').val());
        $('#filter-' + target_item_name + '-is-except-checkbox').prop('checked', param.is_except); 
        if( target_item_name === 'users' ){
            $('#filter-users-is-except-anonymous-checkbox').prop('checked', param.is_except_anonymous);
        }       
        $('#search-' + target_item_name + '-modal-body').html('');
        var path = $('#get-filter-data-path').val();
        var item = $('#filter-' + target_item_name + '-search-item-select').val();
        $.post( path, { 'ids': JSON.stringify(param.ids), 'item': item, 'filter_item': target_item_name }, function(items){
            //検索中のデータ数が多い場合でも、表示を速くきれいにするために先に表示分をappendして
            //残りは後から非同期でappendする
            if( items.length > 0 ){
                cnt = 0;
                while( cnt < 10 ){
                    var data = items.shift();
                    if( data ){
                        append_selected_elm(data, param, target_item_name)
                    }else{
                        break;
                    }
                }
            }
            check_is_filter_selected_elm(target_item_name);
            $('#search-filter-' + target_item_name + '-input').val('');
            $('#search-' + target_item_name + '-modal').modal('show');
            setTimeout(function(){
                $.each(items, function(){
                    append_selected_elm(this, param, target_item_name)
                });
            });
        });
    }

    //スクロールした時にthの下が透けるのを調節する
    //Safariだけはcssだけでは対応できず
    if( browser_ident === 'Safari' ){
        $('.filter-selected-list, .filter-searched-list').on('scroll', function(){
            var offset = $(this).offset();
            $(this).find('.toggle-select').each(function(){
                if( $(this).offset().top < offset.top ){
                    $(this).addClass('invisible');
                }else{
                    $(this).removeClass('invisible');
                }
            });
        });
    }

    $('.filter-modal').on('shown.bs.modal', function(){
        var item_name = $(this).data('itemname');
        $('#search-' + item_name + '-users-input').focus();
    });

    $('.filter-modal').on('hide.bs.modal', function(){
        var item_name = $(this).data('itemname');
        $('#filter-' + item_name + '-selected-list, #filter-' + item_name + '-searched-list').scrollTop(0);
    });
  
    $('.filter-modal [data-input="filter-search"]').on('input', function(){
        var item_name = $(this).data('itemname');
        search_data_for_filter(item_name);
    });

    $('.filter-modal .filter-search-item-select').on('change', function(){
        var item_name = $(this).data('itemname');
        search_data_for_filter(item_name);
    });
 
    //ユーザ検索
    $('#filter-users-is-except-anonymous-checkbox').on('change', function(){
       check_is_filter_selected_elm('users'); 
    });

    $('#filter-users-search-button').on('click', function(){
        $('#filter-users-search-item-select').val('login');
        open_filter_modal('users');
    });

    //ホスト検索
    $('#filter-hosts-search-button').on('click', function(){
        $('#filter-hosts-search-item-select').val('hostname');
        open_filter_modal('hosts');
    });

    //検索modalの検索実行
    $('.filter-modal [data-execute="search"]').on('click', function(){
        var item_name = $(this).data('itemname');
        var filters = JSON.parse($('#pages_filters').val());
        var param = JSON.parse($('#filter-' + item_name + '-param').val());
        filters[item_name]['ids'] = param.ids;
        filters[item_name]['is_except'] = $('#filter-' + item_name + '-is-except-checkbox').prop('checked');
        if( item_name === 'users' ){
            filters[item_name]['is_except_anonymous'] = $('#filter-users-is-except-anonymous-checkbox').prop('checked'); 
        }
        execute_filter(filters);
    });

    //検索modalの検索リセット
    $('.filter-modal [data-reset="search"]').on('click', function(){
        var item_name = $(this).data('itemname');
        var filters = JSON.parse($('#pages_filters').val());
        filters[item_name]['ids'] = [];
        filters[item_name]['is_except'] = false;
        if( item_name === 'users' ){
            filters[item_name]['is_except_anonymous'] = false;
        }
        execute_filter(filters);
    });

    //操作検索
    $('#exec-filter-opes').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        var targets = [];
        $('#filter-opes-menu .ope-select:checked').each(function(){
            targets.push($(this).val());
        });
        if( targets.length === 0 ){
           alert('検索対象を1つ以上選択して下さい。');
           return false;
        }
        filters['opes']['targets'] = targets;
        filters['opes']['is_except'] = $('#filter-opes-is-except-check-box').prop('checked');
        execute_filter(filters);
    });

    //操作検索のリセット
    $('#reset-filter-opes').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['opes']['targets'] = [];
        filters['opes']['is_except'] = false;
        execute_filter(filters);
    });

    //ステータス検索
    $('.filter-statuses').on('click', function(){
        var statuses = $(this).data('value');
        var filters = JSON.parse($('#pages_filters').val());
        filters['statuses'] = statuses;
        execute_filter(filters);
    });
  
    //コメント検索
    $('#form-filter-comment').on('submit', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['comment'] = $('#filter-comment-input').val();
        execute_filter(filters);
        return false;
    });

    //コメント検索のリセット
    $('#reset-filter-comment').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        filters['comment'] = '';
        execute_filter(filters);
    });

    //脆弱性検索
    $('#form-filter-vuls').on('submit', function(){
        var filters = JSON.parse($('#pages_filters').val());
        /*filters['vuls']['title'] = $('#filter-vuls-title-input').val();
        filters['vuls']['html_id'] = $('#filter-vuls-htmlid-input').val();
        filters['vuls']['cve_id'] = $('#filter-vuls-cveid-input').val();*/
        filters['vuls'] = $('#filter-vuls-input').val();
        execute_filter(filters);
        return false;
    });
   
    //脆弱性検索のリセット
    $('#reset-filter-vuls').on('click', function(){
        var filters = JSON.parse($('#pages_filters').val());
        /*filters['vuls']['title'] = '';
        filters['vuls']['html_id'] = '';
        filters['vuls']['cve_id'] = '';*/
        filters['vuls'] = '';
        execute_filter(filters);
    });

    //全フィルタのリセット
    $('#filter-clear').on('click', function() {
        var filters = JSON.parse($('#pages_filters').val());
        filters = {};
        execute_filter(filters);
    });

    //ソート
    $('#sort-created_on').on('click', sort_toggle('created_on'));
    $('#sort-login_name').on('click', sort_toggle('login_name'));
    $('#sort-email').on('click', sort_toggle('email_address'));
    $('#sort-operation').on('click', sort_toggle('operation'));
    $('#sort-hostname').on('click', sort_toggle('hostname'));
    $('#sort-vul_title').on('click', sort_toggle('vul_title'));
    $('#sort-status').on('click', sort_toggle('status'));
    $('#sort-due_date').on('click', sort_toggle('due_date'));

    //ロード時のサマリー表のチェックボックス
    if ($('#pages_all_checked').val() === 'false'){ $('#allSelect').prop('checked', false);}

    var pages_checked = JSON.parse($('#pages_checked').val());
    var all_journal_ids = JSON.parse($('#all-journal-ids').val());
    if(pages_checked.length === all_journal_ids.length && all_journal_ids.length > 0){
        $('#allSelect').prop('checked', true);
    }else{
        $('#allSelect').prop('checked', false);
    }

    //一括ボタンの活性・非活性
    if(pages_checked.length === 0){
        $('.action-btn').prop('disabled', true);
    }else{
        $('.action-btn').prop('disabled', false);
    }

    //pages_checkの値とチェックされているものの整合性を取る
    $(window).on('pageshow', function(){
        var is_all_checked = $('#pages_all_checked').val();
        if(is_all_checked === 'true'){
            var all_ids = JSON.parse($('#all-journal-ids').val());
            $('#SortTR').find('#allSelect, .historySelect').prop('checked', true);
            $('#pages_checked').val(JSON.stringify(all_ids));
        }else{
            $('#SortTR').find('#allSelect, .historySelect').prop('checked', false);
            var pages_checked = JSON.parse($('#pages_checked').val());
            var target_elm = '';
            pages_checked.forEach(function(id){
                target_elm += '.historySelect[value="' + id + '"],';
            });
            target_elm = target_elm.slice(0, -1);
            $(target_elm).prop('checked', true);
        }
    });

    //サマリー表のチェックボックスの選択・非選択
    $('#allSelect').on('change', function(){
        var chk_box = $(this);
        if(chk_box.prop('checked')){
            $('.historySelect').prop('checked', true);
            $('#pages_checked').val($('#all-journal-ids').val());
            $('#pages_all_checked').val('true');
            $('.action-btn').prop('disabled', false);
        }else{
            $('.historySelect').prop('checked', false);
            $('#pages_checked').val('[]');
            $('#pages_all_checked').val('false');
            $('.action-btn').prop('disabled', true);
        }
    });

    $('.historySelect').on('change', function(){
        var chk_box = $(this);
        var id = parseInt(chk_box.val());
        var selected_ids = JSON.parse($('#pages_checked').val());
        var all_ids = JSON.parse($('#all-journal-ids').val());
        if(chk_box.prop('checked')){
            selected_ids.push(id);
        }else{
            var idx = selected_ids.indexOf(id);
            selected_ids.splice(idx, 1);
        }
        $('#pages_checked').val(JSON.stringify(selected_ids));
        if(all_ids.length === selected_ids.length){
            $('#allSelect').prop('checked', true);
            $('#pages_all_checked').val('true');
        }else{
            $('#allSelect').prop('checked', false);
            $('#pages_all_checked').val('false');
        }
        if(selected_ids.length === 0){
            $('.action-btn').prop('disabled', true);
        }else{
            $('.action-btn').prop('disabled', false);
        }
    });

    function execute_edit_comment(journal_id, is_delete_comment){
       var path = $('#edit-comment-path').val();
       var text_area = $('#edit-comment-textarea-' + journal_id);
       var param = {
           'journal_id': journal_id,
           'comment': text_area.val(),
           'comment_delete_flg': is_delete_comment
       };
       $.post(path, param, function(data){
           if( data['err_message'].length > 0 ){
               alert(data['err_message']);
               return false;
           }
           var comment_elm = $('#comment-' + journal_id);
           if( is_delete_comment ){
               text_area.val('');
               comment_elm.attr({ 'data-original-title': '' });
               comment_elm.html('<span class="slanted-font">' + $('#deleted-comment-note').val() + '</span>');
               $('.delete-comment[data-journalid="' + journal_id + '"]').prop('disabled', true);
           }else{
               comment_elm.attr({ 'data-original-title': data['comment'] });
               comment_elm.html(data['comment']);
               $('.delete-comment[data-journalid="' + journal_id + '"]').prop('disabled', false);
           }
           $('.edit-comment[data-journalid="' + journal_id + '"]').prop('disabled', true);
           $('#original-comment-' + journal_id).val(data['comment']);
           var tooltip_target = $('#wrap-comment-' + journal_id);
           tooltip_target.tooltip('show');
           setTimeout(function(){
               tooltip_target.tooltip('hide');
           }, 3000);
            
       }); 
    }

    $('[data-menu="edit-comment"]').on('click', function(e){
        e.stopPropagation();
    });

    $('[data-editfield="comment"]').on('input', function(){
        var j_id = $(this).attr('data-journalid');
        var original_comment = $('#original-comment-' + j_id).val();
        var edit_button = $('.edit-comment[data-journalid="' + j_id + '"]');
        if( original_comment === $(this).val() || $(this).val().length === 0){
            edit_button.prop('disabled', true);
        }else{
            edit_button.prop('disabled', false);
        }
    });

    $('.edit-comment').on('click', function(){
        var conf = confirm('本当に変更してもよろしいですか?');
        if( conf ){
            var j_id = $(this).attr('data-journalid');
            execute_edit_comment(j_id, false);
        }else{
            return false;
        }
    });

    $('.delete-comment').on('click', function(){
        var conf = confirm('本当に削除してもよろしいですか?');
        if( conf ){
            var j_id = $(this).attr('data-journalid');
            $('#edit-comment-delete-flg-' + j_id).val('true');
            execute_edit_comment(j_id, true);
        }else{
            return false;
        }
    });

    //コメント一括編集
    
    function create_bulk_tr_elm(data){
        return $('<tr>').append(
            $('<td>').append($('<div>').attr('class', 'comment').text(data.comment)),
            $('<td>').append(
                $('<div>').html(
                            data.is_anonymous ? '<div class="text-danger">' + data.login + '</div>' : '<div class="user" data-toggle="tooltip" data-title="ログイン名: ' + data.login + '<br>氏名: ' + data.user_fullname + '<br>メールアドレス: ' + data.address + '" data-boundary="window" data-placement="right" data-html="true">' + data.login + '<br>' + '<i class="far fa-envelope mr-1"></i>' + data.address + '</div>'
                          )
            )
        );
    }

    $('#bulk-update-comment-btn').on('click', function(){
        var path = $('#get-data-for-bulk-update-path').val();
        var target_tbody = $('#EditBulkCommentModalTbody');
        target_tbody.find('*').remove();
        $.post(path, { 'journal_ids': $('#pages_checked').val() }, function(histories){
            cnt = 0;
            while( cnt < 15 ){//先にmodalを開い時に表示される分だけ追加
                var history = histories.shift();
                if( !history ){
                   break;
                }
                target_tbody.append(create_bulk_tr_elm(history));
                cnt += 1;
            }
            target_tbody.find('[data-toggle="tooltip"]').tooltip();
            $('#EditBulkCommentModal').modal('show');
            //残りを追加
            var append_elm = setInterval(function(){
                var history = histories.shift();
                if( history ){
                    target_tbody.append(create_bulk_tr_elm(history)); 
                }else{
                    clearInterval(append_elm);
                    target_tbody.find('[data-toggle="tooltip"]').tooltip();
                }
            });
        }); 
    });

    $('#bulk-update-comment-is-delete-checkbox').on('change', function(){
        if( $(this).prop('checked') ){
            $('#edit-bulk-comment-textarea').prop('disabled', true);
        }else{
            $('#edit-bulk-comment-textarea').prop('disabled', false);
        }
    });

    $('#exec-bulk-edit-comment').on('click', function(){
        var conf = confirm('本当に変更してもよろしいですか?');
        if( conf ){
            var page_info = {
                'offset': $('#pages_offset').val(),
                'per_page': $('#pages_per_page').val(),
                'filters': JSON.parse($('#pages_filters').val()),
                'order': $('#pages_order').val()
            };
            $('#bulk-update-comment-page-info').val(JSON.stringify(page_info));
            $('#bulk-update-comment-ids').val($('#pages_checked').val());
            $('#form-bulk-update-comment').submit();
        }else{
            return false;
        }
    });

    //JSON/TSV出力
    $('#download-files-btn').on('click', function(){
        var path = $('#get-download-max-size-path').val();
        $.post(path, {'target': 'history_json_tsv'}, function(data){
            $('#json-tsv-max-download-size').text(data.max_size);
            $('#modalDownload').modal('show'); 
        });
    });

    $('#exec-download').on('click', function(){
        json_tsv_summary_table_progress_download($('#download_select').val(), $('#read-download-data-path').val());
    });

    /*$('#form-download').on('submit', function(){
        $('#download_order').val($('#pages_order').val());
        $('#download_filters').val($('#pages_filters').val());
        $('#download_journal_ids').val($('#pages_checked').val());
    });*

    
    /*$('#exec-download').on('click', function(){     
        var prepare_path = $('#prepare-download-path').val();
        var params = {
            'download[journal_ids]' : $('#pages_checked').val(),
            'download[format]': $('#download_select').val(),
            'download[order]': $('#pages_order').val(),
            'download[filters]': $('#pages_filters').val()
        }

        $.post( prepare_path, params, function(data){
            if( data.is_err ){
                alert('エラーが発生しました。画面をリロードします。');
                $('#pages_form').submit();
            }
            var event_source = new EventSource($('#download-path').val());
   
            event_source.addEventListener("get_data", function(event) {
                //console.log(event.data);
            });

            event_source.addEventListener("done", function(event) {
                this.close();
                //console.log(event);
                console.log('&&&&&&')
            });
        });
    });*/
});
