/* coding: utf-8 */
/* Copyright (C) 2020 SofTek Systems, Inc. */

$(function(){
    init_sidfm();
    init_paginator();
    enable_dropdown_balloon();

    $('.cancel-import').on('click', function(){
        $('#form-to-index-page').submit();
    });

    function import_apply_with_progress_bar(){
        var import_apply_path = $('#sidfm_lproducts_import_apply_path').val();
        var actions = JSON.parse($('#actions').val());
        //優先順位順にしないと、DB更新時に優先順位がずれる
        actions.sort(function(a, b){
            if(a['lprod']['priority'] > b['lprod']['priority']){
                return 1;
            }else{
                return -1;
            }
        });
        var progress_window = get_progress_bar();
        $('body').append(progress_window);
        var executed_actions = 0;
        var total_actions = actions.length;
        var err_messages = new Set();
        var err_cnt = 0;
        var cnt = 0;

        var send_data_of_import = function(){ 
            action = actions[cnt];
            action_data = {'action_data': JSON.stringify(action)};
            $.ajax({
                type: 'POST',
                url: import_apply_path,
                data: action_data,
            }).done(function(result){
                err_message = result['err_message'];
                if( err_message.length > 0 ){
                    err_messages.add(err_message);
                    err_cnt += 1;
                }
                executed_actions += 1;
                var percentage = (executed_actions / total_actions) * 100;
                if( percentage >= 99 && percentage < 100 ){
                    percentage = 99;
                }else{
                    percentage = Math.round(percentage);
                }
                $('#progress-bar').attr('aria-valuenow', percentage).css('width', percentage + '%').text(percentage + '%');
                if( percentage == 100 ){
                    setTimeout(function(){//progress barのbarが満たされるまで待つ
                        if(err_messages.size > 0){
                            err_messages = Array.from(err_messages);
                            alert(err_messages.join('\n') + (err_cnt == total_actions ? '' : '\n※他のデータの登録は完了しています。') + '\nローカルプロダクト設定画面に移動します。');
                            $('#form-to-index-page').submit();
                        }else{
                            $('#form-to-index-page').submit();
                        }
                    },800);
                }else{
                    cnt += 1;
                    send_data_of_import();
                } 
            });
        };
        
        send_data_of_import(); 
    }

    $('.execute-submit-import_apply-form').on('click', function(){
       var get_issue_related_lprod_ids_path = $('#sidfm_lproducts_get_issue_related_lprod_ids_path').val();
       var get_issue_related_remove_version_prod_ids_path = $('#sidfm_lproducts_get_issue_related_remove_version_prod_ids_path').val();
       var actions = JSON.parse($('#actions').val());
       var prod_ids_with_names = {}
       var delete_prod_ids = [];
       var prod_ids_with_version_ids = {}
       actions.forEach(function(action){ 
           if( action['action'] === 'delete' ){     
               delete_prod_ids.push(action['lprod']['product_id']);
               prod_ids_with_names[action['lprod']['product_id']] = action['product_name'];
           }else if( action['action'] === 'modify' && action['is_modify_versions'] ){
               prod_ids_with_version_ids[action['lprod']['product_id']] = action['new_lvers'].map(function(item){ return item['version_id'] });
               prod_ids_with_names[action['lprod']['product_id']] = action['product_name'];
           }
       });
       var issue_related_prod_ids = []; 
       var get_get_issue_related_lprod_ids_req = $.ajax({
           type: 'POST',
           url: get_issue_related_lprod_ids_path,
           data: { 'lprod_ids':  JSON.stringify(delete_prod_ids) }
       }).done(function(ids){
           issue_related_prod_ids.push(...ids);
       });
       var get_issue_related_remove_version_prod_ids_req = $.ajax({
           type: 'POST',
           url: get_issue_related_remove_version_prod_ids_path,
           data: { 'lprod_ids_with_version_ids':  JSON.stringify(prod_ids_with_version_ids) }
       }).done(function(ids){
           issue_related_prod_ids.push(...ids);
       });

       $.when(get_get_issue_related_lprod_ids_req, get_issue_related_remove_version_prod_ids_req).done(function(){
           var issue_related_prod_names = [];
           issue_related_prod_ids.forEach(function(prod_id){
               issue_related_prod_names.push(prod_ids_with_names[prod_id]);
           });
           if( issue_related_prod_names.length > 0 ){
               $('#ProductNameArea > *').remove();
               issue_related_prod_names.sort();
               issue_related_prod_names.forEach(function(prod_name){
                   var tr = $('<tr>');
                   var td = $('<td>').text(prod_name);
                   tr.append(td);
                   $('#ProductNameArea').append(tr);
                   $('#modalIssueRelatedProducts').modal('show');    
               });
           }else{
               import_apply_with_progress_bar(); 
           }  
       });
    });

    $('#exec-import-apply-after-conf').on('click', function(){
        import_apply_with_progress_bar();
    });
});
