# -*- coding: utf-8 -*-
# Plugin's routes
# See: http://guides.rubyonrails.org/routing.html

Rails.application.routes.draw do
  # ダッシュボード
  get 'sidfm/index' => 'sidfm#index'
  get 'sidfm/index_r' => 'sidfm#index_r'

  # 脆弱性一覧
  get 'sidfm/vulnerabilities' => 'sidfm_vulnerabilities#index'
  post 'sidfm/vulnerabilities' => 'sidfm_vulnerabilities#index'
  get 'sidfm/vulnerabilities/index' => 'sidfm_vulnerabilities#index'
  post 'sidfm/vulnerabilities/index' => 'sidfm_vulnerabilities#index'
  get 'sidfm/vulnerabilities/index_r' => 'sidfm_vulnerabilities#index_r'
  post 'sidfm/vulnerabilities/index_r' => 'sidfm_vulnerabilities#index_r'
  get 'sidfm/vulnerabilities/threshold_setting' => 'sidfm_vulnerabilities#threshold_setting'
  post 'sidfm/vulnerabilities/threshold_update' => 'sidfm_vulnerabilities#threshold_update'
  post 'sidfm/vulnerabilities/download' => 'sidfm_vulnerabilities#download'
  post 'sidfm/vulnerabilities/sendmail' => 'sidfm_vulnerabilities#sendmail'
  post 'sidfm/vulnerabilities/update_due_dates' => 'sidfm_vulnerabilities#update_due_dates'
  post 'sidfm/vulnerabilities/update_status' => 'sidfm_vulnerabilities#update_status'
  post 'sidfm/vulnerabilities/send_mail' => 'sidfm_vulnerabilities#send_mail'

  # 脆弱性詳細
  get 'sidfm/vulnerability/:id' => 'sidfm_vulnerability#index'
  post 'sidfm/vulnerability/:id' => 'sidfm_vulnerability#index'
  post 'sidfm/vulnerability/:id/download' => 'sidfm_vulnerability#download'
  post 'sidfm/vulnerability/:id/sendmail' => 'sidfm_vulnerability#sendmail'
  post 'sidfm/vulnerability/:id/update_due_dates' => 'sidfm_vulnerability#update_due_dates'
  post 'sidfm/vulnerability/:id/update_status' => 'sidfm_vulnerability#update_status'
  post 'sidfm/vulnerability/:id/send_mail' => 'sidfm_vulnerability#send_mail'

  # ホスト一覧
  get 'sidfm/hosts' => 'sidfm_hosts#index'
  post 'sidfm/hosts' => 'sidfm_hosts#index'
  get 'sidfm/hosts/index' => 'sidfm_hosts#index'
  post 'sidfm/hosts/index' => 'sidfm_hosts#index'
  get 'sidfm/hosts/index_r' => 'sidfm_hosts#index_r'
  post 'sidfm/hosts/index_r' => 'sidfm_hosts#index_r'
  post 'sidfm/hosts/download' => 'sidfm_hosts#download'
  post 'sidfm/hosts/sendmail' => 'sidfm_hosts#sendmail'
  post 'sidfm/hosts/update_due_dates' => 'sidfm_hosts#update_due_dates'
  post 'sidfm/hosts/update_status' => 'sidfm_hosts#update_status'
  post 'sidfm/hosts/send_mail' => 'sidfm_hosts#send_mail'
  
  # ホスト詳細
  get 'sidfm/host/:id' => 'sidfm_host#index'
  post 'sidfm/host/:id' => 'sidfm_host#index'
  post 'sidfm/host/:id/download' => 'sidfm_host#download'
  post 'sidfm/host/:id/sendmail' => 'sidfm_host#sendmail'
  post 'sidfm/host/:id/update_due_dates' => 'sidfm_host#update_due_dates'
  post 'sidfm/host/:id/update_status' => 'sidfm_host#update_status'
  post 'sidfm/host/:id/send_mail' => 'sidfm_host#send_mail'
  post 'sidfm/host/:id/download_playbook' => 'sidfm_host#download_playbook'

  # カテゴリ管理
  get 'sidfm/categories' => 'sidfm_categories#index'
  get 'sidfm/categories/index' => 'sidfm_categories#index'
  post 'sidfm/categories/create' => 'sidfm_categories#create'
  post 'sidfm/categories/modify' => 'sidfm_categories#modify'
  post 'sidfm/categories/delete' => 'sidfm_categories#delete'

  # ライセンス管理
  get 'sidfm/licenses' => 'sidfm_licenses#index'
  post 'sidfm/licenses' => 'sidfm_licenses#index'
  get 'sidfm/licenses/index' => 'sidfm_licenses#index'
  post 'sidfm/licenses/index' => 'sidfm_licenses#index'
  get 'sidfm/licenses/index_r' => 'sidfm_licenses#index_r'
  post 'sidfm/licenses/index_r' => 'sidfm_licenses#index_r'
  get 'sidfm/licenses/license' => 'sidfm_licenses#license'
  get 'sidfm/licenses/license_setting' => 'sidfm_licenses#license_setting'
  post 'sidfm/licenses/license_update' => 'sidfm_licenses#license_update'
  post 'sidfm/licenses/license_apikey_update' => 'sidfm_licenses#license_apikey_update'
  post 'sidfm/licenses/host_apikey_update' => 'sidfm_licenses#host_apikey_update'
  post 'sidfm/licenses/toggle_host_delete' => 'sidfm_licenses#toggle_host_delete'
  post 'sidfm/licenses/rename_host' => 'sidfm_licenses#rename_host'
  post 'sidfm/licenses/register_apikey_update' => 'sidfm_licenses#register_apikey_update'
  post 'sidfm/licenses/register_apikey_remove' => 'sidfm_licenses#register_apikey_remove'
  get 'sidfm/licenses/api_substr_search' => 'sidfm_licenses#api_substr_search'
  get 'sidfm/licenses/api_get_apps_by_hostname' => 'sidfm_licenses#api_get_apps_by_hostname'
  post 'sidfm/licenses/update_applications' => 'sidfm_licenses#update_applications'
  post 'sidfm/licenses/update_applications_bulk' => 'sidfm_licenses#update_applications_bulk'
  post 'sidfm/licenses/register_host' => 'sidfm_licenses#register_host'
  post 'sidfm/licenses/export' => 'sidfm_licenses#export'
  post 'sidfm/licenses/import' => 'sidfm_licenses#import'
  post 'sidfm/licenses/update_memo' => 'sidfm_licenses#update_memo'
  post 'sidfm/licenses/update_memo_bulk' => 'sidfm_licenses#update_memo_bulk'
  post 'sidfm/licenses/update_refdate' => 'sidfm_licenses#update_refdate'
  post 'sidfm/licenses/update_refdate_bulk' => 'sidfm_licenses#update_refdate_bulk'
  post 'sidfm/licenses/update_categories' => 'sidfm_licenses#update_categories'
  post 'sidfm/licenses/update_categories_bulk' => 'sidfm_licenses#update_categories_bulk'
  post 'sidfm/licenses/load_offline_data' => 'sidfm_licenses#load_offline_data'
  get 'sidfm/licenses/api_validate_new_host' => 'sidfm_licenses#api_validate_new_host'
  post 'sidfm/licenses/set_last_checked_at' => 'sidfm_licenses#set_last_checked_at'
  post 'sidfm/licenses/api_get_new_last_checked_at' => 'sidfm_licenses#api_get_new_last_checked_at'
  post 'sidfm/licenses/set_display_name' => 'sidfm_licenses#set_display_name'
  post 'sidfm/licenses/download_products' => 'sidfm_licenses#download_products'
  get 'sidfm/licenses/import' => 'sidfm_licenses#import'
  post 'sidfm/licenses/new_export' => 'sidfm_licenses#new_export'
  post 'sidfm/licenses/new_import' => 'sidfm_licenses#new_import'
  get 'sidfm/licenses/progress_import_opts' => 'sidfm_licenses#progress_import_opts'
  get 'sidfm/licenses/progress_import_hosts' => 'sidfm_licenses#progress_import_hosts'
  post 'sidfm/licenses/new_import_apply' => 'sidfm_licenses#new_import_apply'

  # ユーザ情報
  get 'sidfm/users' => 'sidfm_users#index'
  get 'sidfm/users/index' => 'sidfm_users#index'
  post 'sidfm/users' => 'sidfm_users#index'
  post 'sidfm/users/index' => 'sidfm_users#index'
  post 'sidfm/users/delete' => 'sidfm_users#delete'
  post 'sidfm/users/create' => 'sidfm_users#create'
  post 'sidfm/users/modify' => 'sidfm_users#modify'
  post 'sidfm/users/modify_category' => 'sidfm_users#modify_category'
  post 'sidfm/users/update_authenticate_bulk' => 'sidfm_users#update_authenticate_bulk'
  post 'sidfm/users/update_autority_bulk' => 'sidfm_users#update_authority_bulk'
  post 'sidfm/users/update_categories_bulk' => 'sidfm_users#update_categories_bulk'
  post 'sidfm/users/update_mail_notification_bulk' => 'sidfm_users#update_mail_notification_bulk'
  post 'sidfm/users/test_email' => 'sidfm_users#test_email'
  post 'sidfm/users/bulk_force_password_change' => 'sidfm_users#bulk_force_password_change'

  # システム設定
  get 'sidfm/system_setting' => 'sidfm_system_setting#index'
  get 'sidfm/system_setting/index' => 'sidfm_system_setting#index'
  post 'sidfm/system_setting/modify_url' => 'sidfm_system_setting#modify_url'
  post 'sidfm/system_setting/modify_mail_address' => 'sidfm_system_setting#modify_mail_address' 
  post 'sidfm/system_setting/modify_password_policy' => 'sidfm_system_setting#modify_password_policy'
  post 'sidfm/system_setting/modify_sync_hosts_num' => 'sidfm_system_setting#modify_sync_hosts_num'
  post 'sidfm/system_setting/set_sesstion_timeout' => 'sidfm_system_setting#set_sesstion_timeout'
  post 'sidfm/system_setting/set_max_rules' => 'sidfm_system_setting#set_max_rules'
  post 'sidfm/system_setting/set_restrict_mail_notification_setting' => 'sidfm_system_setting#set_restrict_mail_notification_setting'
  post 'sidfm/system_setting/set_syncing_check_span' => 'sidfm_system_setting#set_syncing_check_span'
  post 'sidfm/system_setting/set_max_history_download_size' => 'sidfm_system_setting#set_max_history_download_size'
  post 'sidfm/system_setting/set_password_period' => 'sidfm_system_setting#set_password_period'
 
  #ルール設定
  get 'sidfm/rule_setting' => 'sidfm_rule_setting#index'
  get 'sidfm/rule_setting/index' => 'sidfm_rule_setting#index'
  post 'sidfm/rule_setting' => 'sidfm_rule_setting#index'
  post 'sidfm/rule_setting/index' => 'sidfm_rule_setting#index'
  post 'sidfm/rule_setting/create' => 'sidfm_rule_setting#create'
  post 'sidfm/rule_setting/modify' => 'sidfm_rule_setting#modify'
  post 'sidfm/rule_setting/delete' => 'sidfm_rule_setting#delete'
  post 'sidfm/rule_setting/bulk_delete' => 'sidfm_rule_setting#bulk_delete'
  post 'sidfm/rule_setting/bulk_update_rule_flg' => 'sidfm_rule_setting#bulk_update_rule_flg'
 
  #ローカルプロダクト登録
  get 'sidfm/lproducts' => 'sidfm_lproducts#index'
  get 'sidfm/lproducts/index' => 'sidfm_lproducts#index'
  post 'sidfm/lproducts' => 'sidfm_lproducts#index'
  post 'sidfm/lproducts/index' => 'sidfm_lproducts#index'
  post 'sidfm/lproducts/create' => 'sidfm_lproducts#create'
  post 'sidfm/lproducts/modify' => 'sidfm_lproducts#modify'
  post 'sidfm/lproducts/delete' => 'sidfm_lproducts#delete'
  post 'sidfm/lproducts/bulk_lproduct_status' => 'sidfm_lproducts#bulk_lproduct_status'
  post 'sidfm/lproducts/bulk_lproducts_delete' => 'sidfm_lproducts#bulk_lproducts_delete'
  post 'sidfm/lproducts/api_check_is_same_lprod_name' => 'sidfm_lproducts#api_check_is_same_lprod_name'
  post 'sidfm/lproducts/get_issue_related_lprod_ids' => 'sidfm_lproducts#get_issue_related_lprod_ids'
  post 'sidfm/lproducts/export' => 'sidfm_lproducts#export'
  get 'sidfm/lproducts/import' => 'sidfm_lproducts#import'
  get 'sidfm/lproducts/progress_import' => 'sidfm_lproducts#progress_import'
  post 'sidfm/lproducts/read_import_file' => 'sidfm_lproducts#read_import_file'
  post 'sidfm/lproducts/import_apply' => 'sidfm_lproducts#import_apply'
  post 'sidfm/lproducts/get_issue_related_remove_version_prod_ids' => 'sidfm_lproducts#get_issue_related_remove_version_prod_ids'

  #プロダクト一覧画面
  get 'sidfm/products' => 'sidfm_products#index'
  get 'sidfm/products/index' => 'sidfm_products#index'
  post 'sidfm/products' => 'sidfm_products#index'
  post 'sidfm/products/index' => 'sidfm_products#index'
  post 'sidfm/products/download' => 'sidfm_products#download' 

  #ローカル脆弱性登録画面
  get 'sidfm/local_vuls' => 'sidfm_local_vuls#index'
  get 'sidfm/local_vuls/index' => 'sidfm_local_vuls#index'
  post 'sidfm/local_vuls' => 'sidfm_local_vuls#index'
  post 'sidfm/local_vuls/index' => 'sidfm_local_vuls#index'
  post 'sidfm/local_vuls/create' => 'sidfm_local_vuls#create'
  post 'sidfm/local_vuls/modify' => 'sidfm_local_vuls#modify'
  post 'sidfm/local_vuls/delete' => 'sidfm_local_vuls#delete'
  post 'sidfm/local_vuls/check_texts' => 'sidfm_local_vuls#check_texts'
  post 'sidfm/local_vuls/bulk_change_status' => 'sidfm_local_vuls#bulk_change_status'
  post 'sidfm/local_vuls/bulk_delete' => 'sidfm_local_vuls#bulk_delete'
  post 'sidfm/local_vuls/get_issue_related_vul_ids' => 'sidfm_local_vuls#get_issue_related_vul_ids'
  post 'sidfm/local_vuls/export' => 'sidfm_local_vuls#export'
  post 'sidfm/local_vuls/read_import_file' => 'sidfm_local_vuls#read_import_file'
  get 'sidfm/local_vuls/progress_import' => 'sidfm_local_vuls#progress_import'
  get 'sidfm/local_vuls/import' => 'sidfm_local_vuls#import'
  post 'sidfm/local_vuls/import_apply' => 'sidfm_local_vuls#import_apply'

  #履歴情報画面
  get 'sidfm/histories' => 'sidfm_histories#index'
  post 'sidfm/histories' => 'sidfm_histories#index'
  post 'sidfm/histories/edit_comment' => 'sidfm_histories#edit_comment'
  post 'sidfm/histories/get_data_for_bulk_update' => 'sidfm_histories#get_data_for_bulk_update'  
  post 'sidfm/histories/bulk_update_comment' => 'sidfm_histories#bulk_update_comment'  
  post 'sidfm/histories/read_download_data' => 'sidfm_histories#read_download_data'
  post 'sidfm/histories/download' => 'sidfm_histories#download'

  # SIDfm情報
  get 'sidfm/informations/index' => 'sidfm_informations#index'
  get 'sidfm/informations/vuln_list' => 'sidfm_informations#vuln_list'
  get 'sidfm/informations/vuln/:id' => 'sidfm_informations#vuln'
  get 'sidfm/informations/product_index' => 'sidfm_informations#product_index'
  get 'sidfm/informations/product/:id' => 'sidfm_informations#product'
  get 'sidfm/informations/news' => 'sidfm_informations#news'
  get 'sidfm/informations/api_prd2hosts/:id' => 'sidfm_informations#api_prd2hosts'
  post 'sidfm/informations/api_htmlids2issue' => 'sidfm_informations#api_htmlids2issue'

  # 内部API
  post 'sidfm/internal/api/logger' => 'sidfm_internal_api#api_logger'
  get 'sidfm/internal/api/hosts' => 'sidfm_internal_api#api_hosts'
  post 'sidfm/internal/api/hosts' => 'sidfm_internal_api#api_hosts'
  get 'sidfm/internal/api/vulnerabilities' => 'sidfm_internal_api#api_vulnerabilities'
  post 'sidfm/internal/api/vulnerabilities' => 'sidfm_internal_api#api_vulnerabilities'
  post 'sidfm/internal/api/hosts_categories_users_emails' => 'sidfm_internal_api#api_hosts_categories_users_emails'
  post 'sidfm/internal/api/hosts_due_dates' => 'sidfm_internal_api#api_hosts_due_dates'
  post 'sidfm/internal/api/hosts_statuses' => 'sidfm_internal_api#api_hosts_statuses'
  post 'sidfm/internal/api/htmls_statuses' => 'sidfm_internal_api#api_htmlids_statuses'
  post 'sidfm/internal/api/htmls_due_dates' => 'sidfm_internal_api#api_htmlids_due_dates'
  post 'sidfm/internal/api/htmls_emails' => 'sidfm_internal_api#api_htmlids_emails'
  post 'sidfm/internal/api/host_htmls_emails' => 'sidfm_internal_api#api_host_htmlids_emails'
  post 'sidfm/internal/api/host_htmls_due_dates' => 'sidfm_internal_api#api_host_htmlids_due_dates'
  post 'sidfm/internal/api/host_htmls_statuses' => 'sidfm_internal_api#api_host_htmlids_statuses'
  post 'sidfm/internal/api/html_hosts_statuses' => 'sidfm_internal_api#api_htmlid_hosts_statuses'
  post 'sidfm/internal/api/html_hosts_due_dates' => 'sidfm_internal_api#api_htmlid_hosts_due_dates'
  get 'sidfm/internal/api/vulnerabilities_period' => 'sidfm_internal_api#api_vulnerabilities_period'
  post 'sidfm/internal/api/vulnerabilities_period' => 'sidfm_internal_api#api_vulnerabilities_period'
  get 'sidfm/internal/api/vulnerabilities_risk_period' => 'sidfm_internal_api#api_vulnerabilities_risk_period'
  post 'sidfm/internal/api/vulnerabilities_risk_period' => 'sidfm_internal_api#api_vulnerabilities_risk_period'
  get 'sidfm/internal/api/info/find_news_topics' => 'sidfm_internal_api#api_info_find_news_topics'
  post 'sidfm/internal/api/info/find_news_topics' => 'sidfm_internal_api#api_info_find_news_topics'
  get 'sidfm/internal/api/info/find_products' => 'sidfm_internal_api#api_info_find_products'
  post 'sidfm/internal/api/info/find_products' => 'sidfm_internal_api#api_info_find_products'
  get 'sidfm/internal/api/info/recent_product_eols' => 'sidfm_internal_api#api_info_recent_product_eols'
  post 'sidfm/internal/api/info/recent_product_eols' => 'sidfm_internal_api#api_info_recent_product_eols'
  get 'sidfm/internal/api/info/products' => 'sidfm_internal_api#api_info_products'
  post 'sidfm/internal/api/info/products' => 'sidfm_internal_api#api_info_products'
  get 'sidfm/internal/api/info/product' => 'sidfm_internal_api#api_info_product'
  post 'sidfm/internal/api/info/product' => 'sidfm_internal_api#api_info_product'
  get 'sidfm/internal/api/info/product_eols' => 'sidfm_internal_api#api_info_product_eols'
  post 'sidfm/internal/api/info/product_eols' => 'sidfm_internal_api#api_info_product_eols'
  get 'sidfm/internal/api/info/risks' => 'sidfm_internal_api#api_info_risks'
  post 'sidfm/internal/api/info/risks' => 'sidfm_internal_api#api_info_risks'
  get 'sidfm/internal/api/info/areas' => 'sidfm_internal_api#api_info_areas'
  post 'sidfm/internal/api/info/areas' => 'sidfm_internal_api#api_info_areas'
  get 'sidfm/internal/api/info/product_vulns' => 'sidfm_internal_api#api_info_product_vulns'
  post 'sidfm/internal/api/info/product_vulns' => 'sidfm_internal_api#api_info_product_vulns'
  get 'sidfm/internal/api/info/find_vulns' => 'sidfm_internal_api#api_info_find_vulns'
  post 'sidfm/internal/api/info/find_vulns' => 'sidfm_internal_api#api_info_find_vulns'
  get 'sidfm/internal/api/info/sri_categories' => 'sidfm_internal_api#api_info_sri_categories'
  post 'sidfm/internal/api/info/sri_categories' => 'sidfm_internal_api#api_info_sri_categories'
  get 'sidfm/internal/api/info/vuln' => 'sidfm_internal_api#api_info_vuln'
  post 'sidfm/internal/api/info/vuln' => 'sidfm_internal_api#api_info_vuln'
  get 'sidfm/internal/api/info/find_vulns_by_mskb' => 'sidfm_internal_api#api_find_vulns_by_mskb'
  get 'sidfm/internal/api/check_hostname' => 'sidfm_internal_api#api_check_hostname'
  post 'sidfm/internal/api/get_journals' => 'sidfm_internal_api#api_get_journals'  
  post 'sidfm/internal/api/post_journal_comment' => 'sidfm_internal_api#api_post_journal_comment'
  get 'sidfm/internal/api/get_journal_hosts' => 'sidfm_internal_api#api_get_journal_hosts'
  post 'sidfm/internal/api/get_history_vuls' => 'sidfm_internal_api#api_get_history_vuls'
  post 'sidfm/internal/api/store_selected_id' => 'sidfm_internal_api#api_store_selected_id'
  post 'sidfm/internal/api/get_data_for_mail_setting' => 'sidfm_internal_api#api_get_data_for_mail_setting'
  post 'sidfm/internal/api/get_hosts_by_category_id' => 'sidfm_internal_api#api_get_hosts_by_category_id'
  post 'sidfm/internal/api/check_rule' => 'sidfm_internal_api#api_check_rule'
  post 'sidfm/internal/api/get_products_with_hostname' => 'sidfm_internal_api#api_get_products_with_hostname'
  post 'sidfm/internal/api/get_products_and_versions_by_ids' => 'sidfm_internal_api#api_get_products_and_versions_by_ids'
  post 'sidfm/internal/api/replace_mail_keywords' => 'sidfm_internal_api#api_replace_mail_keywords'
  post 'sidfm/internal/api/check_change_rule_category' => 'sidfm_internal_api#check_change_rule_category'
  post 'sidfm/internal/api/check_related_rules' => 'sidfm_internal_api#api_check_related_rules'
  post 'sidfm/internal/api/get_rule_selectable_users' => 'sidfm_internal_api#api_get_rule_selectable_users'
  post 'sidfm/internal/api/check_user_info_registerable' => 'sidfm_internal_api#api_check_user_info_registerable'
  post 'sidfm/internal/api/get_hosts_display_name' => 'sidfm_internal_api#api_get_hosts_display_name'
  post 'sidfm/internal/api/get_product_versions' => 'sidfm_internal_api#api_get_product_versions' 
  post 'sidfm/internal/api/check_keywords' => 'sidfm_internal_api#api_check_keywords'
  post 'sidfm/internal/api/update_view' => 'sidfm_internal_api#update_view'
  post 'sidfm/internal/api/get_host_view_related_htmlids' => 'sidfm_internal_api#api_get_host_view_related_htmlids'
  post 'sidfm/internal/api/get_host_ids_by_hostnames' => 'sidfm_internal_api#api_get_host_ids_by_hostnames'
  post 'sidfm/internal/api/update_host_view_os' => 'sidfm_internal_api#api_update_host_view_os'
  post 'sidfm/internal/api/get_vul_hosts' => 'sidfm_internal_api#api_get_vul_hosts'
  post 'sidfm/internal/api/get_hosts_vuls_related_categories' => 'sidfm_internal_api#api_get_hosts_vuls_related_categories'
  post 'sidfm/internal/api/get_vul_view_heat_map_data' => 'sidfm_internal_api#api_get_vul_view_heat_map_data'
  post 'sidfm/internal/api/get_vul_view_send_mail_data' => 'sidfm_internal_api#api_get_vul_view_send_mail_data'
  post 'sidfm/internal/api/get_host_view_heat_map_data' => 'sidfm_internal_api#api_get_host_view_heat_map_data'
  post 'sidfm/internal/api/get_host_view_send_mail_data' => 'sidfm_internal_api#api_get_host_view_send_mail_data'
  post 'sidfm/internal/api/get_host_send_mail_data' => 'sidfm_internal_api#api_get_host_send_mail_data'
  post 'sidfm/internal/api/get_vul_send_mail_data' => 'sidfm_internal_api#api_get_vul_send_mail_data'
  post 'sidfm/internal/api/get_host_playbook_data' => 'sidfm_internal_api#api_get_host_playbook_data'
  post 'sidfm/internal/api/get_vul_view_cve_info' => 'sidfm_internal_api#api_get_vul_view_cve_info'
  post 'sidfm/internal/api/get_timeline_data' => 'sidfm_internal_api#api_get_timeline_data'
  post 'sidfm/internal/api/get_unfinished_hostids' => 'sidfm_internal_api#api_get_unfinished_hostids'
  post 'sidfm/internal/api/get_unfinished_htmlids' => 'sidfm_internal_api#api_get_unfinished_htmlids'
  post 'sidfm/internal/api/get_history_filter_data' => 'sidfm_internal_api#api_get_history_filter_data'
  post 'sidfm/internal/api/get_download_max_size' => 'sidfm_internal_api#api_get_download_max_size'
  post 'sidfm/internal/api/get_vul_view_cve_info_of_host' => 'sidfm_internal_api#api_get_vul_view_cve_info_of_host'
  post 'sidfm/internal/api/check_category_related_hosts' => 'sidfm_internal_api#api_check_category_related_hosts'
  post 'sidfm/internal/api/check_category_related_users' => 'sidfm_internal_api#api_check_category_related_users'
  post 'sidfm/internal/api/get_has_vuls_hostids' => 'sidfm_internal_api#api_get_has_vuls_hostids'

  # エージェント用データ登録用API
  get 'sidfm/api/register/index' => 'sidfm_register_api#index'
  post 'sidfm/api/register/register_host' => 'sidfm_register_api#register_host'
  post 'sidfm/api/register/send_client_informations' => 'sidfm_register_api#send_client_informations'
  post 'sidfm/api/register/send_windows_client_informations' => 'sidfm_register_api#send_windows_client_informations'

  # SIDfm VM API
  get 'sidfm/api/index' => 'sidfm_vm_api#index'
  post 'sidfm/api/auth' => 'sidfm_vm_api#auth'
  post 'sidfm/api/categories' => 'sidfm_vm_api#categories'
  post 'sidfm/api/hosts' => 'sidfm_vm_api#hosts'
  post 'sidfm/api/vulnerabilities_by_host' => 'sidfm_vm_api#vulnerabilities_by_host'
  post 'sidfm/api/vulnerabilities' => 'sidfm_vm_api#vulnerabilities'
  post 'sidfm/api/hosts_by_vulnerability' => 'sidfm_vm_api#hosts_by_vulnerability'
  post 'sidfm/api/journals' => 'sidfm_vm_api#journals'

  # match ':controller(/:action(/:id))', via: [ :get, :post, :patch ]
end
