# -*- coding: utf-8 -*-

class ModifySidfmdRuleTpInterval < ActiveRecord::Migration

  def change
    reversible do |dir|
      change_table :sidfmd_rule_tp_intervals do |t|
        dir.up {
          t.remove :hour_interval

          # 間隔指定。単位はunitに従う。
          #  unit=hourの場合 1-24
          #  unit=dayの場合 1以上
          #  unit=weekの場合 1以上
          #  unit=monthの場合 1以上
          t.integer :value, index: true, null: false, default: 1

          # 間隔の単位: hour, day, week, month のいずれか。
          t.text :unit, null: false, default: 'hour'
        }
        dir.down {
          t.remove :unit
          t.integer :hour_interval, index: true, null: false
        }
      end
    end
  end

end
