#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

class VulviewCveid < ActiveRecord::Migration
  def up
    # cveの一覧
    create_table :sidfmd_vv_cves do |t|
      t.references :sidfmd_vul_view, foreign_key: true, index: true, null: false
      t.string :cve_id, index: true, null: false

      t.float :c2_base_score, index: true
      t.datetime :c2_create_datetime
      t.datetime :c2_update_datetime, index: true
      t.text :c2_av, index: true
      t.text :c2_ac, index: true
      t.text :c2_au, index: true
      t.text :c2_c, index: true
      t.text :c2_i, index: true
      t.text :c2_a, index: true

      t.float :c3_base_score, index: true
      t.datetime :c3_create_datetime
      t.datetime :c3_update_datetime, index: true
      t.text :c3_av, index: true
      t.text :c3_ac, index: true
      t.text :c3_pr, index: true
      t.text :c3_ui, index: true
      t.text :c3_s, index: true
      t.text :c3_c, index: true
      t.text :c3_i, index: true
      t.text :c3_a, index: true
    end

    SidfmdVulView.sync_whole_data
    SidfmdHostView.sync_whole_data
  end

  def down
    drop_table :sidfmd_vv_cves
  end
end
